<?php
defined('BASEPATH') OR exit('No direct script access allowed');
date_default_timezone_set('Asia/Jakarta');

/*
 * Class Attend
 */
class Attend extends CI_Controller {

	private $username;
	private $ac_payroll_item_id;
	private $access_allowed;

	function __construct() {
		parent::__construct();

		$this->username = $this->session->userdata('username');
		$this->ac_payroll_item_id = $this->session->userdata('ac_payroll_item_id');
		$this->access_allowed = $this->session->userdata('access_allowed');
	}

	public function fixhttps(){
        redirect('attend/scanner_page', 'refresh');
    }

	public function whats_in_today() {

		if (! $this->session->userdata('ac_payroll_item_id')) {
			$this->session->set_flashdata('alert-error', 'Sesi telah berakhir');
			redirect('login');
		}

		$attr = array(
						'countLate' => $this->db->query("SELECT ac_payroll_item.id
													FROM ac_payroll_item
													JOIN ansena_attend ON ansena_attend.ac_payroll_item_id = ac_payroll_item.id
													WHERE DATE_FORMAT(time_scan, '%Y-%m-%d') = DATE_FORMAT(NOW(), '%Y-%m-%d')
													AND attend_status = 'TERLAMBAT'")->num_rows()
					);

		$this->load->view('attend/layouts/header');
		$this->load->view('attend/layouts/navbar');
		$this->load->view('attend/layouts/navbar-sub');
		$this->load->view('attend/layouts/content-wrapper');
		$this->load->view('attend/whats_in_today', $attr);
		$this->load->view('attend/layouts/footer');
		
	}
	// End of function whats_in_today

	public function notif_request() {

		$count = $this->db->query("SELECT id
										  FROM ansena_inout 
										  WHERE DATE_FORMAT(date_inout, '%Y-%m-%d') = DATE_FORMAT(NOW(), '%Y-%m-%d')
										  AND status = 'REQUESTED'")->num_rows();

		echo $count;
		
	}
	// End of function notif_request

	public function auth($session) {

		$key = str_replace(array('-', '_', '~'), array('=', '+', '/'), $session);

		$data['userLevel'] = $this->encyption->decrypt($key);

		$this->session->set_userdata($data);

		redirect('attend');
		
	}
	// End of function auth

	public function index() {
		
		if (! $this->session->userdata('ac_payroll_item_id')) {
			$this->session->set_flashdata('alert-error', 'Sesi telah berakhir');
			redirect('login');
		}

		$this->load->view('attend/layouts/header');
		$this->load->view('attend/layouts/navbar');
		$this->load->view('attend/layouts/content-wrapper');
		$this->load->view('attend/index');
		$this->load->view('attend/layouts/footer');
	}
	// End of function index

	public function scanner_page() {

		$this->load->view('attend/scanner-page');
		
	}
	// End of function scanner_page

	public function scan() {

		$datetime = date('Y-m-d H:i:s');
		$date = date('Y-m-d');
		$time = date('H:i:s');

		// is ijin
		if (substr($this->input->post('barcode'), 0, 4) == 'IJIN') {

			$inout = $this->db->query("SELECT ansena_inout.id, 
											  ansena_inout.ac_payroll_item_id, 
											  date_inout, 
											  scan_in, 
											  scan_out, 
											  shift,
											  is_pulang,
											  ac_payroll_item.name,
											  IF(is_pt = 1, CONCAT('PT. ', REPLACE(ansena_department.name, 'PT. ', '')), REPLACE(ansena_department.name, 'PT. ', '')) AS 'department',
											  team,
											  ansena_division.division
											  FROM ansena_inout
											  JOIN ac_payroll_item ON ac_payroll_item.id = ansena_inout.ac_payroll_item_id
										  	  JOIN ansena_department ON ansena_department.id = ac_payroll_item.office
										  	  JOIN ansena_division ON ansena_division.id = ac_payroll_item.division
											  LEFT JOIN ansena_team_detail ON ansena_team_detail.ac_payroll_item_id = ac_payroll_item.id
    										  LEFT JOIN ansena_team ON ansena_team.id = ansena_team_detail.ansena_team_id
											  WHERE ansena_inout.barcode = '" . $this->input->post('barcode') . "'
											  AND ansena_inout.status = 'SEND'");

			if ($inout->num_rows() > 0){

				$queryInout = $inout->row_array();

				if ($date == $queryInout['date_inout']) {

					if (empty($queryInout['scan_out'])) {

						// Scan out
						$data = array(
										'ac_payroll_item_id' 	=> $queryInout['ac_payroll_item_id'],
										'shift' 				=> $queryInout['shift'],
										'time_scan' 			=> $datetime,
										'attend' 				=> 'OUT',
										'attend_status' 		=> 'IJIN'
									);

						$this->db->insert('ansena_attend', $data);

						$dataUpdate = array(
											'scan_out' => $datetime
										);

						$this->db->where('id', $queryInout['id']);
						$this->db->update('ansena_inout', $dataUpdate);

						if ($queryInout['is_pulang'] == 1) {
							
							// OUT
							$data = array(
										'ac_payroll_item_id' 	=> $queryInout['ac_payroll_item_id'],
										'shift' 				=> $queryInout['shift'],
										'time_scan' 			=> $datetime,
										'attend'				=> 'OUT',
										'attend_status' 		=> 'OK'
									);

							$this->db->insert('ansena_attend', $data);

						}

						echo json_encode(
							array(
								'response' 			=> 'success-out',
								'name' 				=> $queryInout['name'],
								'department' 		=> $queryInout['department'],
								'division' 			=> $queryInout['division'],
								'team'				=> $queryInout['team'],
								'shift'				=> $queryInout['shift'],
								'time_scan' 		=> $time,
								'attend' 			=> 'OUT',
								'attend_status' 	=> 'IJIN',
								'mood'				=> 0,
								'insert_id'			=> 0,
								'title'				=> 0
							)
						);

					} elseif (! empty($queryInout['scan_out']) AND empty($queryInout['scan_in'])) {

						// Scan in
						$data = array(
										'ac_payroll_item_id' 	=> $queryInout['ac_payroll_item_id'],
										'shift' 				=> $queryInout['shift'],
										'time_scan' 			=> $datetime,
										'attend' 				=> 'IN',
										'attend_status' 		=> 'IJIN'
									);

						$this->db->insert('ansena_attend', $data);

						$dataUpdate = array(
											'scan_in' => $datetime
										);

						$this->db->where('id', $queryInout['id']);
						$this->db->update('ansena_inout', $dataUpdate);

						echo json_encode(
							array(
								'response' 			=> 'success',
								'name' 				=> $queryInout['name'],
								'department' 		=> $queryInout['department'],
								'division' 			=> $queryInout['division'],
								'team'				=> $queryInout['team'],
								'shift'				=> $queryInout['shift'],
								'time_scan' 		=> $time,
								'attend' 			=> 'IN',
								'attend_status' 	=> 'IJIN',
								'mood'				=> 0,
								'insert_id'			=> 0,
								'title'				=> 0
							)
						);

					// error-used
					} elseif (! empty($queryInout['scan_out']) AND ! empty($queryInout['scan_in'])) {
						echo json_encode(
									array(
										'response' 			=> 'error-used',
										'mood'				=> 0,
										'insert_id'			=> 0,
										'title'				=> 0
									)
								);
					}

				// error-expired
				} else {
					echo json_encode(
									array(
										'response' 			=> 'error-expired',
										'mood'				=> 0,
										'insert_id'			=> 0,
										'title'				=> 0
									)
								);
				}

			// error-null
			} else {
				echo json_encode(
									array(
										'response' 			=> 'error-null',
										'mood'				=> 0,
										'insert_id'			=> 0,
										'title'				=> 0
									)
								);
			}

		} else {

			// Query Master
			$query = $this->db->query("SELECT ac_payroll_item.id, 
											date_contract,
											ac_payroll_item.name, 
											shift, 
											IF(team IS NOT NULL, CONCAT('t', ansena_team.id), CONCAT('d', ac_payroll_item.office)) AS 'ref_id',
											IF(is_pt = 1, CONCAT('PT. ', REPLACE(ansena_department.name, 'PT. ', '')), REPLACE(ansena_department.name, 'PT. ', '')) AS 'department',
											ansena_team.team,
											ansena_division.division,
											REPLACE(IF(DAYNAME(NOW()) = 'Sunday', JSON_EXTRACT(IF(ansena_team.attend IS NOT NULL, ansena_team.attend, ansena_department.attend), '$.sun'),
											IF(DAYNAME(NOW()) = 'Saturday' AND ac_payroll_item.shift = 1, JSON_EXTRACT(IF(ansena_team.attend IS NOT NULL, ansena_team.attend, ansena_department.attend), '$.sat-1'),
											IF(DAYNAME(NOW()) = 'Saturday' AND ac_payroll_item.shift = 2, JSON_EXTRACT(IF(ansena_team.attend IS NOT NULL, ansena_team.attend, ansena_department.attend), '$.sat-2'),
											IF(ac_payroll_item.shift = 1, JSON_EXTRACT(IF(ansena_team.attend IS NOT NULL, ansena_team.attend, ansena_department.attend), '$.1'), 
											IF(ac_payroll_item.shift = 2, JSON_EXTRACT(IF(ansena_team.attend IS NOT NULL, ansena_team.attend, ansena_department.attend), '$.2'), '-'))))), '\"', '') AS 'working_time_update'
											FROM ac_payroll_item
											JOIN ansena_department ON ansena_department.id = ac_payroll_item.office
											JOIN ansena_division ON ansena_division.id = ac_payroll_item.division
											LEFT JOIN ansena_team_detail ON ansena_team_detail.ac_payroll_item_id = ac_payroll_item.id
											LEFT JOIN ansena_team ON ansena_team.id = ansena_team_detail.ansena_team_id
											WHERE is_active = 1
											AND barcode = '" . $this->input->post('barcode') . "'");

			// is barcode exists
			if ($query->num_rows() > 0) {

				$resultMaster = $query->row_array();

				// User absolute
				if ($resultMaster['id'] == 1) {

					$queryAbsolute = $this->db->query("SELECT attend
															FROM ansena_attend 
															WHERE ac_payroll_item_id = 1
															ORDER BY time_scan DESC
															LIMIT 1");
														
					if ($queryAbsolute->num_rows() > 0) {

						$resultAbsolute = $queryAbsolute->row_array();
						$attendAbsolute = $resultAbsolute['attend'];
					} else {
						$attendAbsolute = 'IN';
					}
											

					if($attendAbsolute == 'IN') {

						$data = array(
									'ac_payroll_item_id' 	=> $resultMaster['id'],
									'shift' 				=> $resultMaster['shift'],
									'time_scan' 			=> $datetime,
									'attend' 				=> 'OUT',
									'attend_status' 		=> 'OK'
								);

						$this->db->insert('ansena_attend', $data);

						echo json_encode(
							array(
								'response' 		=> 'success-out',
								'name' 			=> $resultMaster['name'],
								'department' 	=> $resultMaster['department'],
								'division' 		=> $resultMaster['division'],
								'team'			=> $resultMaster['team'],
								'shift'			=> $resultMaster['shift'],
								'time_scan' 	=> $time,
								'attend' 		=> 'OUT',
								'attend_status' => 'OK',
								'mood'			=> 1,
								'insert_id'		=> $this->db->insert_id(),
								'title'			=> 'Bagaimana perasaanmu hari ini?'
							)
						);

					} else {

						// IN
						$data = array(
									'ac_payroll_item_id' 	=> $resultMaster['id'],
									'shift' 				=> $resultMaster['shift'],
									'time_scan' 			=> $datetime,
									'attend' 				=> 'IN',
									'attend_status' 		=> 'OK'
								);

						$this->db->insert('ansena_attend', $data);

						echo json_encode(
							array(
								'response' 		=> 'success',
								'name' 			=> $resultMaster['name'],
								'department' 	=> $resultMaster['department'],
								'division' 		=> $resultMaster['division'],
								'team'			=> $resultMaster['team'],
								'shift'			=> $resultMaster['shift'],
								'time_scan' 	=> $time,
								'attend' 		=> 'IN',
								'attend_status' => 'OK',
								'mood'			=> 1,
								'insert_id'		=> $this->db->insert_id(),
								'title'			=> 'Apa yang sedang kamu rasakan?'
							)
						);

					}

				} else {

					//$date_contract = $resultMaster['date_contract'];
					$date_contract = date('Y-m-d', strtotime('+10 day'));

					// if date contract finished
					if ($date > $date_contract) {

						echo json_encode(
							array(
									'response' 	=> 'error-date-contract-finished',
									'mood'		=> 0,
									'insert_id'	=> 0,
									'title'		=> 0
							)
						);

					} else {

						$queryAttend = $this->db->query("SELECT ac_payroll_item.id,
																ac_payroll_item.name,
																ansena_attend.shift,
																ac_payroll_item.shift AS 'shift_update',
																DATE_FORMAT(time_scan, '%Y-%m-%d') AS 'latest_scan',
																DATE_FORMAT(time_scan, '%d %b %Y %H:%i:%s') AS 'time_scan_format',
																ansena_attend.attend,
																attend_status,
																IF(is_pt = 1, CONCAT('PT. ', REPLACE(ansena_department.name, 'PT. ', '')), REPLACE(ansena_department.name, 'PT. ', '')) AS 'department',
																ansena_division.division,
																ansena_team.team,
																REPLACE(IF(DAYNAME(NOW()) = 'Sunday', JSON_EXTRACT(IF(ansena_team.attend IS NOT NULL, ansena_team.attend, ansena_department.attend), '$.sun'),
																IF(DAYNAME(NOW()) = 'Saturday' AND ansena_attend.shift = 1, JSON_EXTRACT(IF(ansena_team.attend IS NOT NULL, ansena_team.attend, ansena_department.attend), '$.sat-1'),
																IF(DAYNAME(NOW()) = 'Saturday' AND ansena_attend.shift = 2, JSON_EXTRACT(IF(ansena_team.attend IS NOT NULL, ansena_team.attend, ansena_department.attend), '$.sat-2'),
																IF(ansena_attend.shift = 1, JSON_EXTRACT(IF(ansena_team.attend IS NOT NULL, ansena_team.attend, ansena_department.attend), '$.1'), 
																IF(ansena_attend.shift = 2, JSON_EXTRACT(IF(ansena_team.attend IS NOT NULL, ansena_team.attend, ansena_department.attend), '$.2'), '-'))))), '\"', '') AS 'working_time',
																IF(ansena_attend.shift = 1 AND DAYNAME(NOW()) = 'Friday', '11:30-13:15', 
																IF(ansena_attend.shift = 1, '11:55-13:15',
																IF(ansena_attend.shift = 2 AND DAYNAME(NOW()) = 'Saturday', '16:55-18:15', 
																IF(ansena_attend.shift = 2, '17:55-19:15', '-')))) AS 'break',
																REPLACE(IF(DAYNAME(NOW()) = 'Sunday', JSON_EXTRACT(IF(ansena_team.attend IS NOT NULL, ansena_team.attend, ansena_department.attend), '$.sun'),
																IF(DAYNAME(NOW()) = 'Saturday' AND ac_payroll_item.shift = 1, JSON_EXTRACT(IF(ansena_team.attend IS NOT NULL, ansena_team.attend, ansena_department.attend), '$.sat-1'),
																IF(DAYNAME(NOW()) = 'Saturday' AND ac_payroll_item.shift = 2, JSON_EXTRACT(IF(ansena_team.attend IS NOT NULL, ansena_team.attend, ansena_department.attend), '$.sat-2'),
																IF(ac_payroll_item.shift = 1, JSON_EXTRACT(IF(ansena_team.attend IS NOT NULL, ansena_team.attend, ansena_department.attend), '$.1'), 
																IF(ac_payroll_item.shift = 2, JSON_EXTRACT(IF(ansena_team.attend IS NOT NULL, ansena_team.attend, ansena_department.attend), '$.2'), '-'))))), '\"', '') AS 'working_time_update',
																IF(ac_payroll_item.shift = 1 AND DAYNAME(NOW()) = 'Friday', '11:30-13:15', 
																IF(ac_payroll_item.shift = 1, '11:55-13:15', 
																IF(ac_payroll_item.shift = 2 AND DAYNAME(NOW()) = 'Saturday', '16:55-18:15', 
																IF(ac_payroll_item.shift = 2, '17:55-19:15', '-')))) AS 'break_update'
																FROM ansena_attend 
																JOIN ac_payroll_item ON ac_payroll_item.id = ansena_attend.ac_payroll_item_id
																JOIN ansena_department ON ansena_department.id = ac_payroll_item.office
																JOIN ansena_division ON ansena_division.id = ac_payroll_item.division
																LEFT JOIN ansena_team_detail ON ansena_team_detail.ac_payroll_item_id = ac_payroll_item.id
																LEFT JOIN ansena_team ON ansena_team.id = ansena_team_detail.ansena_team_id
																WHERE ansena_attend.ac_payroll_item_id = " . $resultMaster['id'] . "
																ORDER BY time_scan DESC
																LIMIT 1");
						
						// Query jam masuk kerja
						$custom = $this->db->query("SELECT JSON_EXTRACT(detail, '$." . $date . "') AS 'time_custom'
															FROM attend_custom
															WHERE ref_id = '" . $resultMaster['ref_id'] . "'
															AND JSON_EXTRACT(detail, '$." . $date . "')");

						// Query jam masuk kerja setelah event
						$custom_event = $this->db->query("SELECT time_attend 
															FROM attend_custom 
															JOIN events_attend ON events_attend.event_id = SUBSTRING(ref_id, 2)
															WHERE SUBSTRING(ref_id, 1, 1) = 'x'
															AND DATE_FORMAT(attend_custom.created_time, '%Y-%m-%d') = DATE_FORMAT(NOW(), '%Y-%m-%d')
															AND ac_payroll_item_id = " . $resultMaster['id']);

						// if attend (pertama kali absen) null
						if ($queryAttend->num_rows() == 0) {

							$workingTimeUpdate = explode('-', str_replace('"', '', $resultMaster['working_time_update']));

							// Custom jam masuk kerja
							if ($custom->num_rows() > 0) {
								$custom = $custom->row_array();
								// if time custom
								if (! empty($custom['time_custom']) || $custom['time_custom'] != '') {
									$workingTimeFinal = str_replace('"', '', $custom['time_custom']);
								} else {
									$workingTimeFinal = $workingTimeUpdate[0];
								}
							} else {
								$workingTimeFinal = $workingTimeUpdate[0];
							}

							// Custom jam masuk kerja setelah event
							if ($custom_event->num_rows() > 0) {
								$custom_event = $custom_event->row_array();
								// if time custom
								if (! empty($custom_event['time_attend']) || $custom_event['time_attend'] != '') {
									$workingTimeFinal = $custom_event['time_attend'];
								} else {
									$workingTimeFinal = $workingTimeUpdate[0];
								}
							}
							
							// IN + OK
							if ($time <= $workingTimeFinal) {

								$data = array(
												'ac_payroll_item_id' 	=> $resultMaster['id'],
												'shift' 				=> $resultMaster['shift'],
												'time_scan' 			=> $datetime,
												'attend' 				=> 'IN',
												'attend_status' 		=> 'OK'
											);

								$this->db->insert('ansena_attend', $data);

								echo json_encode(
									array(
										'response' 			=> 'success',
										'name' 				=> $resultMaster['name'],
										'department' 		=> $resultMaster['department'],
										'division' 			=> $resultMaster['division'],
										'team'				=> $resultMaster['team'],
										'shift'				=> $resultMaster['shift'],
										'time_scan' 		=> $time,
										'attend' 			=> 'IN',
										'attend_status' 	=> 'OK',
										'mood'				=> 1,
										'insert_id'			=> $this->db->insert_id(),
										'title'				=> 'Apa yang sedang kamu rasakan?'
									)
								);
							// IN + TERLAMBAT
							} else {

								$data = array(
												'ac_payroll_item_id' 	=> $resultMaster['id'],
												'shift' 				=> $resultMaster['shift'],
												'time_scan' 			=> $datetime,
												'attend' 				=> 'IN',
												'attend_status' 		=> 'TERLAMBAT'
											);

								$this->db->insert('ansena_attend', $data);

								echo json_encode(
									array(
										'response' 		=> 'success',
										'name' 			=> $resultMaster['name'],
										'department' 	=> $resultMaster['department'],
										'division' 		=> $resultMaster['division'],
										'team'			=> $resultMaster['team'],
										'shift'			=> $resultMaster['shift'],
										'time_scan' 	=> $time,
										'attend' 		=> 'IN',
										'attend_status' => 'TERLAMBAT',
										'mood'			=> 1,
										'insert_id'		=> $this->db->insert_id(),
										'title'			=> 'Apa yang sedang kamu rasakan?'
									)
								);

							}

						} else {

							$result = $queryAttend->row_array();

							// Terakhir absen hari sebelumnnya
							if ($result['latest_scan'] != $date AND $result['attend'] == 'IN') {

								// OUT
								$data = array(
											'ac_payroll_item_id' 	=> $result['id'],
											'shift' 				=> $result['shift_update'],
											'time_scan' 			=> $datetime,
											'attend'				=> 'OUT',
											'attend_status' 		=> 'OK'
										);

								$this->db->insert('ansena_attend', $data);

								echo json_encode(
									array(
										'response' 		=> 'success-out',
										'name' 			=> $result['name'],
										'department' 	=> $result['department'],
										'division' 		=> $result['division'],
										'team'			=> $result['team'],
										'shift'			=> $result['shift_update'],
										'time_scan' 	=> $time,
										'attend' 		=> 'OUT',
										'attend_status' => 'OK',
										'mood'			=> 1,
										'insert_id'		=> $this->db->insert_id(),
										'title'			=> 'Bagaimana perasaanmu hari ini?'
									)
								);
							// Terakhir absen hari sebelumnya
							} elseif ($result['latest_scan'] != $date AND $result['attend'] == 'OUT') {

								$workingTime = explode('-', str_replace('"', '', $result['working_time']));
								$workingTimeUpdate = explode('-', str_replace('"', '', $result['working_time_update']));

								// Custom jam masuk kerja
								if ($custom->num_rows() > 0) {
									$custom = $custom->row_array();
									// if time custom
									if (! empty($custom['time_custom']) || $custom['time_custom'] != '') {
										$workingTimeFinal = str_replace('"', '', $custom['time_custom']);
									} else {
										$workingTimeFinal = $workingTimeUpdate[0];
									}
								} else {
									$workingTimeFinal = $workingTimeUpdate[0];
								}

								// Custom jam masuk kerja setelah event
								if ($custom_event->num_rows() > 0) {
									$custom_event = $custom_event->row_array();
									// if time custom
									if (! empty($custom_event['time_attend']) || $custom_event['time_attend'] != '') {
										$workingTimeFinal = $custom_event['time_attend'];
									} else {
										$workingTimeFinal = $workingTimeUpdate[0];
									}
								}

								// IN + OK
								if ($time <= $workingTimeFinal) {

									// IN
									$data = array(
												'ac_payroll_item_id' 	=> $result['id'],
												'shift' 				=> $result['shift_update'],
												'time_scan' 			=> $datetime,
												'attend' 				=> 'IN',
												'attend_status' 		=> 'OK'
											);

									$this->db->insert('ansena_attend', $data);

									echo json_encode(
										array(
											'response' 		=> 'success',
											'name' 			=> $result['name'],
											'department' 	=> $result['department'],
											'division' 		=> $result['division'],
											'team'			=> $result['team'],
											'shift'			=> $result['shift_update'],
											'time_scan' 	=> $time,
											'attend' 		=> 'IN',
											'attend_status' => 'OK',
											'mood'			=> 1,
											'insert_id'		=> $this->db->insert_id(),
											'title'			=> 'Apa yang sedang kamu rasakan?'
										)
									);
								
								// IN + TERLAMBAT
								} else {

									// IN + TERLAMBAT
									$data = array(
												'ac_payroll_item_id' 	=> $result['id'],
												'shift' 				=> $result['shift_update'],
												'time_scan' 			=> $datetime,
												'attend' 				=> 'IN',
												'attend_status' 		=> 'TERLAMBAT'
											);

									$this->db->insert('ansena_attend', $data);

									echo json_encode(
										array(
											'response' 		=> 'terlambat',
											'name' 			=> $result['name'],
											'department' 	=> $result['department'],
											'division' 		=> $result['division'],
											'team'			=> $result['team'],
											'shift'			=> $result['shift'],
											'time_scan' 	=> $time,
											'attend' 		=> 'IN',
											'attend_status' => 'TERLAMBAT',
											'mood'			=> 1,
											'insert_id'		=> $this->db->insert_id(),
											'title'			=> 'Apa yang sedang kamu rasakan?'
										)
									);

								}
							// Terakhir absen hari sebelumnya
							} elseif ($result['latest_scan'] != $date AND ($result['attend'] == 'OK' ||
																		$result['attend'] == 'CUTI' ||
																		$result['attend'] == 'SAKIT' ||
																		$result['attend'] == 'IJIN' ||
																		$result['attend'] == 'ALPA' ||
																		$result['attend'] == 'TERLAMBAT' ||
																		$result['attend'] == 'SK1' ||
																		$result['attend'] == 'SK2' ||
																		$result['attend'] == 'SK3')) {
								
								$workingTime = explode('-', str_replace('"', '', $result['working_time']));
								$workingTimeUpdate = explode('-', str_replace('"', '', $result['working_time_update']));
								
								// Custom jam masuk kerja
								if ($custom->num_rows() > 0) {
									$custom = $custom->row_array();
									// if time custom
									if (! empty($custom['time_custom']) || $custom['time_custom'] != '') {
										$workingTimeFinal = str_replace('"', '', $custom['time_custom']);
									} else {
										$workingTimeFinal = $workingTimeUpdate[0];
									}
								} else {
									$workingTimeFinal = $workingTimeUpdate[0];
								}

								// Custom jam masuk kerja setelah event
								if ($custom_event->num_rows() > 0) {
									$custom_event = $custom_event->row_array();
									// if time custom
									if (! empty($custom_event['time_attend']) || $custom_event['time_attend'] != '') {
										$workingTimeFinal = $custom_event['time_attend'];
									} else {
										$workingTimeFinal = $workingTimeUpdate[0];
									}
								}

								// IN + OK
								if ($time <= $workingTimeFinal) {

									// IN
									$data = array(
												'ac_payroll_item_id' 	=> $result['id'],
												'shift' 				=> $result['shift_update'],
												'time_scan' 			=> $datetime,
												'attend' 				=> 'IN',
												'attend_status' 		=> 'OK'
											);

									$this->db->insert('ansena_attend', $data);

									echo json_encode(
										array(
											'response' 		=> 'success',
											'name' 			=> $result['name'],
											'department' 	=> $result['department'],
											'division' 		=> $result['division'],
											'team'			=> $result['team'],
											'shift'			=> $result['shift_update'],
											'time_scan' 	=> $time,
											'attend' 		=> 'IN',
											'attend_status' => 'OK',
											'mood'			=> 1,
											'insert_id'		=> $this->db->insert_id(),
											'title'			=> 'Apa yang sedang kamu rasakan?'
										)
									);
								
								// IN + TERLAMBAT
								} else {

									// IN + TERLAMBAT
									$data = array(
												'ac_payroll_item_id' 	=> $result['id'],
												'shift' 				=> $result['shift_update'],
												'time_scan' 			=> $datetime,
												'attend' 				=> 'IN',
												'attend_status' 		=> 'TERLAMBAT'
											);

									$this->db->insert('ansena_attend', $data);

									echo json_encode(
										array(
											'response' 		=> 'terlambat',
											'name' 			=> $result['name'],
											'department' 	=> $result['department'],
											'division' 		=> $result['division'],
											'team'			=> $result['team'],
											'shift'			=> $result['shift'],
											'time_scan' 	=> $time,
											'attend' 		=> 'IN',
											'attend_status' => 'TERLAMBAT',
											'mood'			=> 1,
											'insert_id'		=> $this->db->insert_id(),
											'title'			=> 'Apa yang sedang kamu rasakan?'
										)
									);

								}
																		
							} else {

								$workingTime = explode('-', str_replace('"', '', $result['working_time']));
								$workingTimeUpdate = explode('-', str_replace('"', '', $result['working_time_update']));

								$breakTime = explode('-', $result['break']);
								$breakTimeUpdate = explode('-', $result['break_update']);

								// Custom jam masuk kerja
								if ($custom->num_rows() > 0) {
									$custom = $custom->row_array();
									// if time custom
									if (! empty($custom['time_custom']) || $custom['time_custom'] != '') {
										$workingTimeFinal = str_replace('"', '', $custom['time_custom']);
									} else {
										$workingTimeFinal = $workingTimeUpdate[0];
									}
								} else {
									$workingTimeFinal = $workingTimeUpdate[0];
								}

								// Custom jam masuk kerja setelah event
								if ($custom_event->num_rows() > 0) {
									$custom_event = $custom_event->row_array();
									// if time custom
									if (! empty($custom_event['time_attend']) || $custom_event['time_attend'] != '') {
										$workingTimeFinal = $custom_event['time_attend'];
									} else {
										$workingTimeFinal = $workingTimeUpdate[0];
									}
								}

								if ($result['attend'] == 'OUT' && $result['attend_status'] == 'IJIN') {

									echo json_encode(
													array(
														'response' 		=> 'cant-scan',
														'time_scan'		=> $result['time_scan_format'],
														'attend' 		=> $result['attend'],
														'shift'			=> $result['shift'],
														'mood'			=> 0,
														'insert_id'		=> 0,
														'title'			=> 0
													)
												);

								} else {

									// if jam kerja null (Hari minggu)
									if ($result['working_time'] == NULL AND $result['working_time_update'] == NULL) {

										if ($result['attend'] == 'IN') {

											// OUT
											$data = array(
														'ac_payroll_item_id' 	=> $result['id'],
														'shift' 				=> $result['shift'],
														'time_scan' 			=> $datetime,
														'attend' 				=> 'OUT',
														'attend_status' 		=> 'OK'
													);

											$this->db->insert('ansena_attend', $data);

											echo json_encode(
												array(
													'response' 		=> 'success-out',
													'name' 			=> $result['name'],
													'department' 	=> $result['department'],
													'division' 		=> $result['division'],
													'team'			=> $result['team'],
													'shift'			=> $result['shift'],
													'time_scan' 	=> $time,
													'attend' 		=> 'OUT',
													'attend_status' => 'OK',
													'mood'			=> 1,
													'insert_id'		=> $this->db->insert_id(),
													'title'			=> 'Bagaimana perasaanmu hari ini?'
												)
											);

										} elseif ($result['attend'] == 'OUT') {

											// IN
											$data = array(
														'ac_payroll_item_id' 	=> $result['id'],
														'shift' 				=> $result['shift_update'],
														'time_scan' 			=> $datetime,
														'attend' 				=> 'IN',
														'attend_status' 		=> 'OK'
													);

											$this->db->insert('ansena_attend', $data);

											echo json_encode(
												array(
													'response' 		=> 'success',
													'name' 			=> $result['name'],
													'department' 	=> $result['department'],
													'division' 		=> $result['division'],
													'team'			=> $result['team'],
													'shift'			=> $result['shift_update'],
													'time_scan' 	=> $time,
													'attend' 		=> 'IN',
													'attend_status' => 'OK',
													'mood'			=> 1,
													'insert_id'		=> $this->db->insert_id(),
													'title'			=> 'Apa yang sedang kamu rasakan?'
												)
											);

										}

									} else {

										// Out custome condition
										if ($time >= $workingTime[1]) {

											if ($result['attend'] == 'IN' || $result['attend'] == 'OK') {

												// OUT
												$data = array(
															'ac_payroll_item_id' 	=> $result['id'],
															'shift' 				=> $result['shift'],
															'time_scan' 			=> $datetime,
															'attend' 				=> 'OUT',
															'attend_status' 		=> 'OK'
														);

												$this->db->insert('ansena_attend', $data);

												echo json_encode(
													array(
														'response' 		=> 'success-out',
														'name' 			=> $result['name'],
														'department' 	=> $result['department'],
														'division' 		=> $result['division'],
														'team'			=> $result['team'],
														'shift'			=> $result['shift'],
														'time_scan' 	=> $time,
														'attend' 		=> 'OUT',
														'attend_status' => 'OK',
														'mood'			=> 1,
														'insert_id'		=> $this->db->insert_id(),
														'title'			=> 'Bagaimana perasaanmu hari ini?'
													)
												);

											} else {

												// IN
												$data = array(
															'ac_payroll_item_id' 	=> $result['id'],
															'shift' 				=> $result['shift'],
															'time_scan' 			=> $datetime,
															'attend' 				=> 'IN',
															'attend_status' 		=> 'OK'
														);

												$this->db->insert('ansena_attend', $data);

												echo json_encode(
													array(
														'response' 		=> 'success',
														'name' 			=> $result['name'],
														'department' 	=> $result['department'],
														'division' 		=> $result['division'],
														'team'			=> $result['team'],
														'shift'			=> $result['shift'],
														'time_scan' 	=> $time,
														'attend' 		=> 'IN',
														'attend_status' => 'OK',
														'mood'			=> 1,
														'insert_id'		=> $this->db->insert_id(),
														'title'			=> 'Apa yang sedang kamu rasakan?'
													)
												);

											}

										// Break (ISTIRAHAT)
										} elseif ($time >= $breakTime[0] AND $time <= $breakTime[1]) {

											if ($result['attend'] == 'IN' || $result['attend'] == 'OK') {

												// ISTIRAHAT OUT
												$data = array(
															'ac_payroll_item_id'	=> $result['id'],
															'shift' 				=> $result['shift'],
															'time_scan' 			=> $datetime,
															'attend' 				=> 'OUT',
															'attend_status' 		=> 'ISTIRAHAT'
														);

												$this->db->insert('ansena_attend', $data);

												echo json_encode(
													array(
														'response' 		=> 'break-out',
														'name' 			=> $result['name'],
														'department' 	=> $result['department'],
														'division' 		=> $result['division'],
														'team'			=> $result['team'],
														'shift'			=> $result['shift'],
														'time_scan' 	=> $time,
														'attend' 		=> 'OUT',
														'attend_status' => 'ISTIRAHAT',
														'mood'			=> 0,
														'insert_id'		=> 0,
														'title'			=> 0
													)
												);

											} elseif ($result['attend'] == 'OUT') {

												// ISTIRAHAT IN
												$data = array(
															'ac_payroll_item_id' 	=> $result['id'],
															'shift' 				=> $result['shift'],
															'time_scan' 			=> $datetime,
															'attend' 				=> 'IN',
															'attend_status' 		=> 'ISTIRAHAT'
														);

												$this->db->insert('ansena_attend', $data);

												echo json_encode(
													array(
														'response' 		=> 'break-in',
														'name' 			=> $result['name'],
														'department' 	=> $result['department'],
														'division' 		=> $result['division'],
														'team'			=> $result['team'],
														'shift'			=> $result['shift'],
														'time_scan' 	=> $time,
														'attend' 		=> 'IN',
														'attend_status' => 'ISTIRAHAT',
														'mood'			=> 0,
														'insert_id'		=> 0,
														'title'			=> 0
													)
												);

											}
											// End of attend

										} else {

											// lebih dari jam istirahat
											if ($result['attend'] == 'OUT' AND $result['attend_status'] == 'ISTIRAHAT') {

												$data = array(
															'ac_payroll_item_id' 	=> $result['id'],
															'shift' 				=> $result['shift'],
															'time_scan' 			=> $datetime,
															'attend' 				=> 'IN',
															'attend_status' 		=> 'ISTIRAHAT'
														);

												$this->db->insert('ansena_attend', $data);

												echo json_encode(
													array(
														'response' 		=> 'break-late',
														'name' 			=> $result['name'],
														'department' 	=> $result['department'],
														'division' 		=> $result['division'],
														'team'			=> $result['team'],
														'shift'			=> $result['shift'],
														'time_scan' 	=> $time,
														'attend' 		=> 'IN',
														'attend_status' => 'ISTIRAHAT',
														'mood'			=> 0,
														'insert_id'		=> 0,
														'title'			=> 0
													)
												);

											} elseif ($result['attend'] == 'OUT' AND $time <= $workingTimeFinal) {

												$data = array(
															'ac_payroll_item_id' 	=> $result['id'],
															'shift' 				=> $result['shift'],
															'time_scan' 			=> $datetime,
															'attend' 				=> 'IN',
															'attend_status' 		=> 'OK'
														);

												$this->db->insert('ansena_attend', $data);

												echo json_encode(
													array(
														'response' 		=> 'success',
														'name' 			=> $result['name'],
														'department' 	=> $result['department'],
														'division' 		=> $result['division'],
														'team'			=> $result['team'],
														'shift'			=> $result['shift'],
														'time_scan' 	=> $time,
														'attend' 		=> 'IN',
														'attend_status' => 'OK',
														'mood'			=> 1,
														'insert_id'		=> $this->db->insert_id(),
														'title'			=> 'Apa yang sedang kamu rasakan?'
													)
												);

											} elseif ($result['attend'] == 'OUT' AND $time > $workingTimeFinal AND $time < $workingTimeUpdate[1]) {

												$data = array(
															'ac_payroll_item_id' 	=> $result['id'],
															'shift' 				=> $result['shift'],
															'time_scan' 			=> $datetime,
															'attend' 				=> 'IN',
															'attend_status' 		=> 'TERLAMBAT'
														);

												$this->db->insert('ansena_attend', $data);

												echo json_encode(
													array(
														'response' 		=> 'success',
														'name'	 		=> $result['name'],
														'department' 	=> $result['department'],
														'division' 		=> $result['division'],
														'team'			=> $result['team'],
														'shift'			=> $result['shift'],
														'time_scan' 	=> $time,
														'attend' 		=> 'IN',
														'attend_status' => 'TERLAMBAT',
														'mood'			=> 1,
														'insert_id'		=> $this->db->insert_id(),
														'title'			=> 'Apa yang sedang kamu rasakan?'
													)
												);
																									

											} else {

												echo json_encode(
													array(
														'response' 		=> 'cant-scan',
														'time_scan'		=> $result['time_scan_format'],
														'attend' 		=> $result['attend'],
														'shift'			=> $result['shift'],
														'mood'			=> 0,
														'insert_id'		=> 0,
														'title'			=> 0
													)
												);

											}

											// if ($result['attend'] == 'IN') {

											// 	// IJIN OUT
											// 	$data = array(
											// 				'ac_payroll_item_id' => $result['id'],
											// 				'shift' => $result['shift'],
											// 				'time_scan' => date('Y-m-d H:i:s'),
											// 				'attend' => 'OUT',
											// 				'attend_status' => 'IJIN'
											// 			);

											// 	$this->db->insert('ansena_attend', $data);

											// 	echo 'success';

											// } elseif ($result['attend'] == 'OUT') {

											// 	// IJIN IN
											// 	$data = array(
											// 				'ac_payroll_item_id' => $result['id'],
											// 				'shift' => $result['shift'],
											// 				'time_scan' => date('Y-m-d H:i:s'),
											// 				'attend' => 'IN',
											// 				'attend_status' => 'IJIN'
											// 			);

											// 	$this->db->insert('ansena_attend', $data);

											// 	echo 'success';

											// }
											// // End of attend

										}
										// End of after working time

									}

								}

							}
							// End of is exists

						}

					}

				}

			} else {

				echo json_encode(
									array(
										'response' 			=> 'error-null',
										'mood'				=> 0,
										'insert_id'			=> 0,
										'title'				=> 0
									)
								);
			}

		}
	
	}
	// End of function scan

	public function insert_mood() {

		$insert_id 		= $this->input->post('insert_id');
		$mood 			= $this->input->post('mood');

		$data = array(
						'mood' => $mood
		);

		$this->db->where('id', $insert_id);
		$this->db->update('ansena_attend', $data);

	}
	// End of function insert_mood

	public function display_employee_by_department() {

		if (! $this->session->userdata('ac_payroll_item_id')) {
			$this->session->set_flashdata('alert-error', 'Sesi telah berakhir');
			redirect('login');
		}

		$query = $this->db->query("SELECT id, name
								 FROM ac_payroll_item
								 WHERE is_active = 1
								 AND office = " . $this->input->get('department') . "
								 AND barcode IS NULL")->result();

		$html = '<select class="form-control select2" id="key" name="key">
			  	<option value="" disabled selected>Pilih Karyawan</option>';

		foreach ($query as $row) :
			
			$html .= '<option value="' . $row->id . '">' . $row->name . '</option>';

		endforeach;

		$html .= '</select>';

		echo $html;

	}
	// End of function display_employee_by_department

	public function hrd_act() {

		if (! $this->session->userdata('ac_payroll_item_id')) {
			$this->session->set_flashdata('alert-error', 'Sesi telah berakhir');
			redirect('login');
		}
		
		$sintax = $this->restrict_lib->query_access();

		$attr = array(
						'department' => $this->db->query($sintax)->result()
		);

		$this->load->view('attend/layouts/header');
		$this->load->view('attend/layouts/navbar');
		$this->load->view('attend/hrd-act/navbar-sub');
		$this->load->view('attend/layouts/content-wrapper');
		$this->load->view('attend/hrd-act/hrd-act', $attr);
		$this->load->view('attend/layouts/footer');
		
	}
	// End of function hrd_act

	public function load_attend_list() {

		if (! $this->session->userdata('ac_payroll_item_id')) {
			$this->session->set_flashdata('alert-error', 'Sesi telah berakhir');
			redirect('login');
		}

		$department = $this->input->get('department');

		if (substr($department, 0, 1) == 'd') {

			$department = preg_replace('/[^0-9]/', '', $department);

			$query = $this->db->query("SELECT ac_payroll_item.id,
											ac_payroll_item.name,
											MIN(ansena_attend.time_scan) AS time_scan,
											ansena_attend.shift,
											ansena_attend.mood,
											SUBSTRING(MIN(CONCAT(time_scan, attend)), 20) AS 'attend',
											SUBSTRING(MIN(CONCAT(time_scan, attend_status)), 20) AS 'attend_status',
											IF(SUM(hrd_act) > 0, '<i class=\"fa fa-check clr-green\"></i>', '') AS 'hrd_act',
											ansena_division.division,
											ac_payroll_item.division AS id_division
											FROM ac_payroll_item
											LEFT JOIN ansena_attend ON ansena_attend.ac_payroll_item_id = ac_payroll_item.id AND DATE_FORMAT(time_scan,   '%Y-%m-%d') = '" . $this->input->get('date_input') . "' AND attend != 'OUT'
											JOIN ansena_division ON ansena_division.id = ac_payroll_item.division
											WHERE office = " . $department . "
											AND ac_payroll_item.is_active = 1
											AND barcode IS NOT NULL
											GROUP BY ac_payroll_item.id
											ORDER BY ansena_division.sort, name ASC");

			$queryOut = $this->db->query("SELECT ac_payroll_item.id,
											ac_payroll_item.name,
											MIN(ansena_attend.time_scan) AS time_scan,
											ansena_attend.shift,
											ansena_attend.mood,
											SUBSTRING(MIN(CONCAT(time_scan, attend)), 20) AS 'attend',
											SUBSTRING(MIN(CONCAT(time_scan, attend_status)), 20) AS 'attend_status',
											IF(SUM(hrd_act) > 0, '<i class=\"fa fa-check clr-green\"></i>', '') AS 'hrd_act',
											ansena_division.division,
											ac_payroll_item.division AS id_division
											FROM ac_payroll_item
											LEFT JOIN ansena_attend ON ansena_attend.ac_payroll_item_id = ac_payroll_item.id AND DATE_FORMAT(time_scan,   '%Y-%m-%d') = '" . $this->input->get('date_input') . "' AND attend = 'OUT'
											JOIN ansena_division ON ansena_division.id = ac_payroll_item.division
											WHERE office = " . $department . "
											AND ac_payroll_item.is_active = 1
											AND barcode IS NOT NULL
											GROUP BY ac_payroll_item.id
											ORDER BY ansena_division.sort, name ASC");
		
		} else {

			$department = preg_replace('/[^0-9]/', '', $department);

			$query = $this->db->query("SELECT ac_payroll_item.id,
											ac_payroll_item.name,
											MIN(ansena_attend.time_scan) AS time_scan,
											ansena_attend.shift,  
											ansena_attend.mood,    
											SUBSTRING(MIN(CONCAT(time_scan, attend)), 20) AS 'attend',
											SUBSTRING(MIN(CONCAT(time_scan, attend_status)), 20) AS 'attend_status',
											IF(SUM(hrd_act) > 0, '<i class=\"fa fa-check clr-green\"></i>', '') AS 'hrd_act',
											ansena_division.division,
											ac_payroll_item.division AS id_division
											FROM ac_payroll_item
											LEFT JOIN ansena_attend ON ansena_attend.ac_payroll_item_id = ac_payroll_item.id AND DATE_FORMAT(time_scan,   '%Y-%m-%d') = '" . $this->input->get('date_input') . "' AND attend != 'OUT'
											JOIN ansena_team_detail ON ansena_team_detail.ac_payroll_item_id = ac_payroll_item.id
											JOIN ansena_division ON ansena_division.id = ac_payroll_item.division
			                                WHERE ansena_team_detail.ansena_team_id = " . $department . "
											AND ac_payroll_item.is_active = 1
											AND barcode IS NOT NULL
											GROUP BY ac_payroll_item.id
											ORDER BY ansena_division.sort, name ASC");

			$queryOut = $this->db->query("SELECT ac_payroll_item.id,
											ac_payroll_item.name,
											MIN(ansena_attend.time_scan) AS time_scan,
											ansena_attend.shift,  
											ansena_attend.mood,    
											SUBSTRING(MIN(CONCAT(time_scan, attend)), 20) AS 'attend',
											SUBSTRING(MIN(CONCAT(time_scan, attend_status)), 20) AS 'attend_status',
											IF(SUM(hrd_act) > 0, '<i class=\"fa fa-check clr-green\"></i>', '') AS 'hrd_act',
											ansena_division.division,
											ac_payroll_item.division AS id_division
											FROM ac_payroll_item
											LEFT JOIN ansena_attend ON ansena_attend.ac_payroll_item_id = ac_payroll_item.id AND DATE_FORMAT(time_scan,   '%Y-%m-%d') = '" . $this->input->get('date_input') . "' AND attend = 'OUT'
											JOIN ansena_team_detail ON ansena_team_detail.ac_payroll_item_id = ac_payroll_item.id
											JOIN ansena_division ON ansena_division.id = ac_payroll_item.division
			                                WHERE ansena_team_detail.ansena_team_id = " . $department . "
											AND ac_payroll_item.is_active = 1
											AND barcode IS NOT NULL
											GROUP BY ac_payroll_item.id
											ORDER BY ansena_division.sort, name ASC");

		}

		if ($query->num_rows() > 0) {

			$attr = array(
							'date_input' => $this->input->get('date_input'),
							'attend' => $query->result(),
							'attend_out' => $queryOut->result()
						);

			$this->load->view('attend/hrd-act/attend-list', $attr);

		} else {
			echo 'error-null';
		}
		
	}
	// End of function load_attend_list

	public function submit_hrd_act($date_input) {

		if (! $this->session->userdata('ac_payroll_item_id')) {
			$this->session->set_flashdata('alert-error', 'Sesi telah berakhir');
			redirect('login');
		}

		$key = $this->input->post('key');
		$hrd_act = $this->input->post('hrd_act');
		$feeling = $this->input->post('feeling');

		$param_before = $this->input->post('param_before');
		$feeling_before = $this->input->post('feeling_before');

		$this->db->trans_start();

		for ($i = 0; $i < count($hrd_act); $i++) :

			if ($hrd_act[$i] != '') {

				$x = explode('-', $key[$i]);

				if ($hrd_act[$i] == 'TERLAMBAT') {
					$attend = 'IN';
				} else {
					$attend = $hrd_act[$i];
				} 

				$attend_before = 'null';

				if ($x[0] == 't') {

					$this->db->query("UPDATE ansena_attend SET attend = '" . $attend . "',
												attend_status = '" . $hrd_act[$i] . "',
												mood = '" . $feeling[$i] . "',
												hrd_act = 1
												WHERE ac_payroll_item_id = " . $x[1] . "
												AND DATE_FORMAT(time_scan, '%Y-%m-%d') = '" . $date_input . "'");

				} else {

					$countHrdAct = $this->db->query("SELECT id
															FROM ansena_attend
															WHERE ac_payroll_item_id = " . $x[1] . "
															AND hrd_act = 1
															AND attend_status != 'TERLAMBAT'
															AND time_scan = '" . $date_input . " 00:00:00'")->num_rows();

					if ($countHrdAct > 0) {

						$this->db->query("UPDATE ansena_attend SET time_scan = '" . $date_input . "',
												attend	= '" . $attend . "',
												attend_status = '" . $hrd_act[$i] . "',
												mood = '" . $feeling[$i] . "',
												hrd_act = 1
												WHERE ac_payroll_item_id = " . $x[1] . "
												AND hrd_act = 1 
												AND attend_status != 'TERLAMBAT'
												AND time_scan = '" . $date_input . " 00:00:00'");

					} else {
						$data = array(
									'ac_payroll_item_id' => $x[1],
									'time_scan' => $date_input,
									'shift' => 1,
									'attend' => $attend,
									'attend_status' => $hrd_act[$i],
									'hrd_act' => 1,
									'mood' => $feeling[$i]
								);

						$this->db->insert('ansena_attend', $data);
					}
				
				}

				// Log: param, object, param_before, param_after, date
				$this->log_lib->log(2, $x[1], $param_before[$i], $attend, $date_input);

				if ($feeling[$i] != '') {

					switch($feeling[$i]) :
						case 1:
							$feeling_mood = 'senang';
							break;
						case 2:
							$feeling_mood = 'sedih';
							break;
						case 3:
							$feeling_mood = '';
							break;
						case 4:
							$feeling_mood = 'bosan';
							break;
						case 5:
							$feeling_mood = 'biasa';
							break;
						case 6:
							$feeling_mood = 'tertekan';
							break;
						case 7:
							$feeling_mood = 'sakit';
							break;
						case 8:
							$feeling_mood = '';
							break;
					endswitch;
					
					$this->log_lib->log(3, $x[1], $feeling_before[$i], $feeling_mood, $date_input);
				}
			}

		endfor;

		if ($this->db->trans_status() === false) {
			$this->db->trans_rollback();
			echo 'error';
		} else {
			$this->db->trans_commit();
			echo 'success';
		}
	}
	// End of function submit_hrd_act

	public function submit_hrd_act_out($date_input) {

		if (! $this->session->userdata('ac_payroll_item_id')) {
			$this->session->set_flashdata('alert-error', 'Sesi telah berakhir');
			redirect('login');
		}
		
		$this->db->trans_start();

		$key = $this->input->post('key');
		$hrd_act = $this->input->post('hrd_act');
		$feeling = $this->input->post('feeling');

		$datetime_input = $date_input . " " . date('H:i:s');

		$param_before = $this->input->post('param_before');
		$feeling_before = $this->input->post('feeling_before');

		for ($i = 0; $i < count($hrd_act); $i++) {

			$attend = $hrd_act[$i];

			if ($hrd_act[$i] != '') {

				$countHrdAct = $this->db->query("SELECT id
														FROM ansena_attend
														WHERE ac_payroll_item_id = " . $key[$i] . "
														AND attend_status = 'OUT'
														AND DATE_FORMAT(time_scan, '%Y-%m-%d') = '" . $date_input . "'")->num_rows();

				if ($countHrdAct > 0) {

					$this->db->query("UPDATE ansena_attend SET time_scan = '" . $datetime_input . "',
											attend	= '" . $attend . "',
											attend_status = '" . $hrd_act[$i] . "',
											mood = '" . $feeling[$i] . "',
											hrd_act = 1
											WHERE ac_payroll_item_id = " . $key[$i] . "
											AND hrd_act = 1 
											AND attend_status = 'OUT'
											AND DATE_FORMAT(time_scan, '%Y-%m-%d') = '" . $date_input . "'");

				} else {
					$data = array(
								'ac_payroll_item_id' => $key[$i],
								'time_scan' => $datetime_input,
								'shift' => 1, 
								'attend' => $attend,
								'attend_status' => $hrd_act[$i],
								'hrd_act' => 1,
								'mood' => $feeling[$i]
							);

					$this->db->insert('ansena_attend', $data);
				}

				// Log: param, object, param_before, param_after, date
				$this->log_lib->log(2, $key[$i], $param_before[$i], $attend, $date_input);

				if ($feeling[$i] != '') {

					switch($feeling[$i]) :
						case 1:
							$feeling_mood = 'senang';
							break;
						case 2:
							$feeling_mood = 'sedih';
							break;
						case 3:
							$feeling_mood = '';
							break;
						case 4:
							$feeling_mood = 'bosan';
							break;
						case 5:
							$feeling_mood = 'biasa';
							break;
						case 6:
							$feeling_mood = 'tertekan';
							break;
						case 7:
							$feeling_mood = 'sakit';
							break;
						case 8:
							$feeling_mood = '';
							break;
					endswitch;

					$this->log_lib->log(3, $key[$i], $feeling_before[$i], $feeling_mood, $date_input);
				}

			}
		}

		if ($this->db->trans_status() === false) {
			$this->db->trans_rollback();
			echo 'error';
		} else {
			$this->db->trans_commit();
			echo 'success';
		}
	}
	// End of function submit_hrd_act_out

	public function monthly_report() {

		if (! $this->session->userdata('ac_payroll_item_id')) {
			$this->session->set_flashdata('alert-error', 'Sesi telah berakhir');
			redirect('login');
		}

		$sintax = $this->restrict_lib->query_access();

		$attr = array(
						'department' => $this->db->query($sintax)->result()
		);

		$this->load->view('attend/layouts/header');
		$this->load->view('attend/layouts/navbar');
		$this->load->view('attend/monthly-report/navbar-sub');
		$this->load->view('attend/layouts/content-wrapper');
		$this->load->view('attend/monthly-report/monthly-report', $attr);
		$this->load->view('attend/layouts/footer');
	}
	// End of function monthly_report

	public function monthly_report_result() {

		if (! $this->session->userdata('ac_payroll_item_id')) {
			$this->session->set_flashdata('alert-error', 'Sesi telah berakhir');
			redirect('login');
		}

		$query = $this->db->query("SELECT attend_date, detail
										  FROM ansena_attend_resume
										  WHERE DATE_FORMAT(attend_date, '%Y-%m') = '" . $this->input->post('month') . "'
										  ORDER BY attend_date ASC")->result_array();

		$dept_id = $this->input->post('department');

		if (substr($dept_id, 0, 1) == 'd') {

			$dept_id = preg_replace('/[^0-9]/', '', $dept_id);

			$masterData = $this->db->query("SELECT id, name, division
												FROM ac_payroll_item
												WHERE is_active = 1
												AND office = '" . $dept_id. "'
												AND DATE_FORMAT(date_join, '%Y-%m') <= '" . $this->input->post('month') . "'
												AND barcode IS NOT NULL
												AND ac_payroll_item.id != 1
												ORDER BY name ASC")->result();

			$department = $this->db->query("SELECT IF(is_pt = 1, CONCAT('PT. ', REPLACE(ansena_department.name, 'PT. ', '')), REPLACE(ansena_department.name, 'PT. ', '')) AS 'name' FROM ansena_department WHERE id = " . $dept_id)->row_array();

		} else {

			$dept_id = preg_replace('/[^0-9]/', '', $dept_id);

			$masterData = $this->db->query("SELECT ac_payroll_item.id, name, division
												FROM ac_payroll_item
												JOIN ansena_team_detail ON ansena_team_detail.ac_payroll_item_id = ac_payroll_item.id
												WHERE is_active = 1
												AND ansena_team_detail.ansena_team_id = '" . $dept_id . "'
												AND DATE_FORMAT(date_join, '%Y-%m') <= '" . $this->input->post('month') . "'
												AND barcode IS NOT NULL
												AND ac_payroll_item.id != 1
												ORDER BY name ASC")->result();

			$department = $this->db->query("SELECT CONCAT(IF(is_pt = 1, CONCAT('PT. ', REPLACE(ansena_department.name, 'PT. ', '')), REPLACE(ansena_department.name, 'PT. ', '')), ' (', team, ')') AS 'name'
												   FROM ansena_team
												   JOIN ansena_department ON ansena_department.id = ansena_team.dept_id 
												   WHERE ansena_team.id = " . $dept_id)->row_array();

		}

		$attr = array(
						'department' => $department['name'],
						'period' => date('M Y', strtotime($this->input->post('month'))),
						'attendData' => $query,
						'masterData' => $masterData
					);

		if (count($query) == 0 || count($masterData) == 0) {
			echo 'error-null';
		} else {
			$this->load->view('attend/monthly-report/monthly-report-result', $attr);
		}

	}
	// End of function monthly_report_result

	public function history() {

		if (! $this->session->userdata('ac_payroll_item_id')) {
			$this->session->set_flashdata('alert-error', 'Sesi telah berakhir');
			redirect('login');
		}

		$sintax = $this->restrict_lib->query_access();

		$attr = array(
						'department' => $this->db->query($sintax)->result()
		);

		$this->load->view('attend/layouts/header');
		$this->load->view('attend/layouts/navbar');
		$this->load->view('attend/history/navbar-sub');
		$this->load->view('attend/layouts/content-wrapper');
		$this->load->view('attend/history/history', $attr);
		$this->load->view('attend/layouts/footer');
		
	}
	// End of function history

	public function load_history_list() {

		if (! $this->session->userdata('ac_payroll_item_id')) {
			$this->session->set_flashdata('alert-error', 'Sesi telah berakhir');
			redirect('login');
		}

		$department = $this->input->get('department');

		if (substr($department, 0, 1) == 'd') {

			$department = preg_replace('/[^0-9]/', '', $department);

			$query = $this->db->query("SELECT ac_payroll_item.id AS id, 
											  ac_payroll_item.name, 
											  ansena_attend.shift, 
											  IF(SUBSTRING(MAX(CONCAT(time_scan, ansena_attend.attend)), 20) = 'IN', 'di kantor', IF(SUBSTRING(MAX(CONCAT  (time_scan, ansena_attend.attend)), 20) = 'OUT', 'keluar kantor', '-')) AS 'latest_position',
											  SUM(IF(ansena_attend.attend = 'OUT' AND ansena_attend.attend_status = 'IJIN', 1, 0)) AS 'total_ijin' 
											  FROM ansena_attend 
											  RIGHT JOIN ac_payroll_item ON ac_payroll_item.id = ansena_attend.ac_payroll_item_id 
											  WHERE office = " . $department . "
											  AND DATE_FORMAT(time_scan, '%Y-%m-%d') = '" . $this->input->get('date_input') . "' 
											  GROUP BY ac_payroll_item.id
											  ORDER BY name ASC");
		
		} else {

			$department = preg_replace('/[^0-9]/', '', $department);

			$query = $this->db->query("SELECT ac_payroll_item.id AS id, 
											  ac_payroll_item.name, 
			                                  ansena_attend.shift, 
			                                  IF(SUBSTRING(MAX(CONCAT(time_scan, ansena_attend.attend)), 20) = 'IN', 'di kantor', IF(SUBSTRING(MAX(CONCAT  (time_scan, ansena_attend.attend)), 20) = 'OUT', 'keluar kantor', '-')) AS 'latest_position',
			                                  SUM(IF(ansena_attend.attend = 'OUT' AND ansena_attend.attend_status = 'IJIN', 1, 0)) AS 'total_ijin' 
			                                  FROM ansena_attend 
			                                  RIGHT JOIN ac_payroll_item ON ac_payroll_item.id = ansena_attend.ac_payroll_item_id 
			                                  JOIN ansena_team_detail ON ansena_team_detail.ac_payroll_item_id = ac_payroll_item.id
			                                  WHERE ansena_team_detail.ansena_team_id = " . $department . "
											  AND DATE_FORMAT(time_scan, '%Y-%m-%d') = '" . $this->input->get('date_input') . "' 
											  GROUP BY ac_payroll_item.id
											  ORDER BY name ASC");

		}

		if ($query->num_rows() > 0) {

			$attr = array(
							'date_input' => $this->input->get('date_input'),
							'attend' => $query->result()
						);

			$this->load->view('attend/history/attend-list', $attr);

		} else {
			echo 'error-null';
		}
	}
	// End of function load_history_list

	public function load_detail_history($date_input) {

		if (! $this->session->userdata('ac_payroll_item_id')) {
			$this->session->set_flashdata('alert-error', 'Sesi telah berakhir');
			redirect('login');
		}

		$attr = array(
						'history' => $this->db->query("SELECT ansena_attend.attend,
															  attend_status,
															  time_scan
															  FROM ansena_attend 
															  JOIN ac_payroll_item ON ac_payroll_item.id = ansena_attend.ac_payroll_item_id
															  WHERE DATE_FORMAT(time_scan, '%Y-%m-%d') = '" . $date_input . "'
															  AND ac_payroll_item.id = " . $this->input->get('id') . "
															  ORDER BY time_scan DESC")->result()
					);

		$this->load->view('attend/history/attend-history', $attr);
		
	}
	// End of function load_detail_history

	public function generate_barcode_inout($id) {

		$barcode = 'IJIN-' . $id . '-' . strtotime(date('Y-m-d H:i:s'));

		$data = array(
						'barcode' => $barcode,
						'date_inout' => date('Y-m-d'),
						'ac_payroll_item_id' => $id,
						'no_wa' => $this->input->post('no_wa'),
						'noted' => $this->input->post('keperluan'),
						'is_request' => 1,
						'status' => 'REQUESTED',
						'created' => date('Y-m-d H:i:s')
					);

		$this->db->insert('ansena_inout', $data);

		$this->load->library('ciqrcode'); //pemanggilan library QR CODE

		$config['cacheable'] = true; //boolean, the default is true
		$config['cachedir'] = './assets/'; //string, the default is application/cache/
		$config['errorlog'] = './assets/'; //string, the default is application/logs/
		$config['imagedir'] = './assets/barcode-ijin/'; //direktori penyimpanan qr code
		$config['quality'] = true; //boolean, the default is true
		$config['size'] = '1024'; //interger, the default is 1024
		$config['black'] = array(224,255,255); // array, default is array(255,255,255)
		$config['white'] = array(70,130,180); // array, default is array(0,0,0)
		$this->ciqrcode->initialize($config);

		$image_name = $barcode.'.png'; //buat name dari qr code

		$params['data'] = $barcode; //data yang akan di jadikan QR CODE
		$params['level'] = 'H'; //H=High
		$params['size'] = 10;
		$params['savename'] = FCPATH.$config['imagedir'].$image_name; //simpan image QR CODE ke folder assets/barcode/
		$this->ciqrcode->generate($params); // fungsi untuk generate QR CODE

		echo 'success';
	}
	// End of function generate_barcode_inout

	public function permission_inout() {

		if (! $this->session->userdata('ac_payroll_item_id')) {
			$this->session->set_flashdata('alert-error', 'Sesi telah berakhir');
			redirect('login');
		}

		$attr = array(
						'department' => $this->db->query("SELECT CONCAT(IF(is_pt = 1, CONCAT('PT. ', REPLACE(name, 'PT. ', '')), REPLACE(name, 'PT. ', '')), ' (', team, ')') AS 'name',
															     CONCAT('t', ansena_team.id) AS 'id'
																 FROM ansena_team 
																 LEFT JOIN ansena_department ON ansena_department.id = ansena_team.dept_id 
																 UNION ALL 
																 SELECT IF(is_pt = 1, CONCAT('PT. ', REPLACE(name, 'PT. ', '')), REPLACE(name, 'PT. ', '')) AS 'name',
																 CONCAT('d', ansena_department.id) AS 'id'
																 FROM ansena_department 
																 LEFT OUTER JOIN ansena_team ON ansena_team.dept_id = ansena_department.id 
																 WHERE ansena_team.id IS NULL")->result()
					);

		$this->load->view('attend/layouts/header');
		$this->load->view('attend/layouts/navbar');
		$this->load->view('attend/permission-inout/navbar-sub');
		$this->load->view('attend/layouts/content-wrapper');
		$this->load->view('attend/permission-inout/permission-inout', $attr);
		$this->load->view('attend/layouts/footer');
		
	}
	// End of function permission_inout

	public function load_employee_list() {

		if (! $this->session->userdata('ac_payroll_item_id')) {
			$this->session->set_flashdata('alert-error', 'Sesi telah berakhir');
			redirect('login');
		}

		$department = $this->input->get('department');

		if (substr($department, 0, 1) == 'd') {

			$department = preg_replace("/[^0-9]/", "", $department);

			$query = $this->db->query("SELECT id, name, shift
											FROM ac_payroll_item
											WHERE is_active = 1
											AND office = '" . $department . "'
											ORDER BY name ASC")->result();
		
		} else {

			$department = preg_replace("/[^0-9]/", "", $department);

			$query = $this->db->query("SELECT ac_payroll_item.id, name, shift
											  FROM ac_payroll_item
											  JOIN ansena_team_detail ON ansena_team_detail.ac_payroll_item_id = ac_payroll_item.id
											  WHERE is_active = 1
											  AND ansena_team_id = " . $department . "
											  ORDER BY name ASC")->result();
		}

		$attr = array(
						'result' => $query
					);

		$this->load->view('attend/permission-inout/employee-list', $attr);
		
	}
	// End of function load_employee_list

	public function load_generate_barcode($id) {

		$attr = array(
						'data' => $this->db->query('SELECT id, name, phone FROM ac_payroll_item WHERE is_active = 1 AND id = ' . $id)->row_array()
					);

		$this->load->view('attend/permission-inout/generate-barcode', $attr);
		
	}
	// End of function load_generate_barcode

	public function print_barcode($id) {

		$attr = array(
						'inoutData' => $this->db->query("SELECT ac_payroll_item.name, 
																ansena_department.name AS department, 
																ansena_division.division,
																noted,
																ansena_inout.barcode
																FROM ansena_inout
																JOIN ac_payroll_item ON ac_payroll_item.id = ansena_inout.ac_payroll_item_id
																JOIN ansena_department ON ansena_department.id = ac_payroll_item.office
																JOIN ansena_division ON ansena_division.id = ac_payroll_item.division
																WHERE ansena_inout.id = " . $id)->row_array()
					);

		$this->load->view('attend/permission-inout/print-barcode', $attr);
		
	}
	// End of function print_barcode

	public function request_permission_list() {

		if (! $this->session->userdata('ac_payroll_item_id')) {
			$this->session->set_flashdata('alert-error', 'Sesi telah berakhir');
			redirect('login');
		}

		$this->load->view('attend/layouts/header');
		$this->load->view('attend/layouts/navbar');
		$this->load->view('attend/request-permission-list/navbar-sub');
		$this->load->view('attend/layouts/content-wrapper');
		$this->load->view('attend/request-permission-list/content');
		$this->load->view('attend/layouts/footer');
		
	}
	// End of function request_permission_list

	public function request_permission() {

		if (! $this->session->userdata('ac_payroll_item_id')) {
			$this->session->set_flashdata('alert-error', 'Sesi telah berakhir');
			redirect('login');
		}

		$this->load->view('attend/layouts/header');
		$this->load->view('attend/request-permission/navbar');
		$this->load->view('attend/request-permission/navbar-sub');
		$this->load->view('attend/layouts/content-wrapper');
		$this->load->view('attend/request-permission/content');
		$this->load->view('attend/request-permission/footer');
		
	}
	// End of function request_permission

	public function load_request_permission() {

		if (! $this->session->userdata('ac_payroll_item_id')) {
			$this->session->set_flashdata('alert-error', 'Sesi telah berakhir');
			redirect('login');
		}

		$query = $this->db->query("SELECT ac_payroll_item.id,
										  ac_payroll_item.name, 
										  ansena_department.name AS department, 
										  ansena_division.division,
										  phone,
										  barcode
										  FROM ac_payroll_item
										  JOIN ansena_department ON ansena_department.id = ac_payroll_item.office
										  JOIN ansena_division ON ansena_division.id = ac_payroll_item.division
										  WHERE ac_payroll_item.barcode = '" . $this->input->get('barcode') . "'
										  AND is_active = 1");

		if ($query->num_rows() > 0) {

			$attr = array(
							'data' => $query->row_array()
						);

			$this->load->view('attend/request-permission/form-request', $attr);

		} else {
			echo 'error-null';
		}
			
	}
	// End of function load_request_permission

	public function save_request() {

		if (! $this->session->userdata('ac_payroll_item_id')) {
			$this->session->set_flashdata('alert-error', 'Sesi telah berakhir');
			redirect('login');
		}

		$barcode = 'IJIN-' . $this->input->post('id') . '-' . strtotime(date('Y-m-d H:i:s'));

		$data = array(
						'barcode' => $barcode,
						'date_inout' => date('Y-m-d'),
						'ac_payroll_item_id' => $this->input->post('id'),
						'no_wa' => $this->input->post('no_wa'),
						'noted' => $this->input->post('keperluan'),
						'is_pulang'	=> $this->input->post('is_pulang'),
						'is_request' => 1,
						'status' => 'REQUESTED',
						'created' => date('Y-m-d H:i:s')
					);

		$this->load->library('ciqrcode'); //pemanggilan library QR CODE

		$config['cacheable'] = true; //boolean, the default is true
		$config['cachedir'] = './assets/'; //string, the default is application/cache/
		$config['errorlog'] = './assets/'; //string, the default is application/logs/
		$config['imagedir'] = './assets/barcode-ijin/'; //direktori penyimpanan qr code
		$config['quality'] = true; //boolean, the default is true
		$config['size'] = '1024'; //interger, the default is 1024
		$config['black'] = array(224,255,255); // array, default is array(255,255,255)
		$config['white'] = array(70,130,180); // array, default is array(0,0,0)
		$this->ciqrcode->initialize($config);

		$image_name = $barcode.'.png'; //buat name dari qr code

		$params['data'] = $barcode; //data yang akan di jadikan QR CODE
		$params['level'] = 'H'; //H=High
		$params['size'] = 10;
		$params['savename'] = FCPATH.$config['imagedir'].$image_name; //simpan image QR CODE ke folder assets/barcode/
		$this->ciqrcode->generate($params); // fungsi untuk generate QR CODE

		$this->db->insert('ansena_inout', $data);

		echo 'success';
		
	}
	// End of function save_request

	public function send_link() {

		$query = $this->db->query("SELECT id, barcode, no_wa FROM ansena_inout WHERE id = " . $this->input->get('id'))->row_array();

		if (substr($query['no_wa'], 0, 1) == '0') {
			$no_wa = '62' . substr($query['no_wa'], 1);
		} else {
			$no_wa = $query['no_wa'];
		}


		$content = 'https://wa.me/' . $no_wa . '?text=' . site_url('attend/link/' . $query['id']);

		$data = array(
						'status' => 'SEND',
						'created' => date('Y-m-d H:i:s')
					);

		$this->db->where('id', $this->input->get('id'));
		$this->db->update('ansena_inout', $data);

		echo $content;

	}
	// End of function send_link

	public function cancel_link() {

		if (! $this->session->userdata('ac_payroll_item_id')) {
			$this->session->set_flashdata('alert-error', 'Sesi telah berakhir');
			redirect('login');
		}

		$data = array(
						'status' => 'CANCEL',
						'created' => date('Y-m-d H:i:s')
					);

		$this->db->where('id', $this->input->get('id'));
		$this->db->update('ansena_inout', $data);

	}

	public function link($id) {

		if (! $this->session->userdata('ac_payroll_item_id')) {
			$this->session->set_flashdata('alert-error', 'Sesi telah berakhir');
			redirect('login');
		}

		$attr = array(
						'data' => $this->db->query("SELECT ansena_inout.id,
														   ac_payroll_item.name,
														   ansena_department.name AS 'department',
														   ansena_division.division,
														   ansena_inout.noted,
														   ansena_inout.barcode
														   FROM ansena_inout
														   JOIN ac_payroll_item ON ac_payroll_item.id = ansena_inout.ac_payroll_item_id
														   JOIN ansena_department ON ansena_department.id = ac_payroll_item.office
														   JOIN ansena_division ON ansena_division.id = ac_payroll_item.division
														   WHERE ansena_inout.id = " . $id)->row_array()
					);

		$this->load->view('attend/link', $attr);
		
	}
	// End of function link

	public function server_side_data() {

		$query = $this->db->query("SELECT ac_payroll_item.id, 
						barcode, ac_payroll_item.name AS employee_name, 
						is_pt,
						ansena_department.name AS 'department',
						ansena_division.division, 
						ansena_team.team,
						ansena_attend.shift,
						DATE_FORMAT(time_scan, '%H:%i:%s') AS time_scan, 
						ansena_attend.attend, 
						attend_status
						FROM ac_payroll_item
						JOIN ansena_department ON ansena_department.id = ac_payroll_item.office
						JOIN ansena_division ON ansena_division.id = ac_payroll_item.division
						JOIN ansena_attend ON ansena_attend.ac_payroll_item_id = ac_payroll_item.id
						LEFT JOIN ansena_team_detail ON ansena_team_detail.ac_payroll_item_id = ac_payroll_item.id
						LEFT JOIN ansena_team ON ansena_team.id = ansena_team_detail.ansena_team_id
						WHERE DATE_FORMAT(time_scan, '%Y-%m-%d') = DATE_FORMAT(NOW(), '%Y-%m-%d')
						ORDER BY time_scan DESC");

		$results = $query->result();

		$data = array();

		foreach ($results as $rows) :

			$row = array();

			$row[] = $rows->employee_name;

			if ($rows->is_pt == 1) {
				$department = 'PT. ' . str_replace('PT. ', '', $rows->department);
			} else {
				$department = str_replace('PT. ', '', $rows->department);
			}

			if ($rows->team != '') {
				$department = $department . ' (' . $rows->team . ')';
			}

			$row[] = $department;

			$row[] = $rows->division;

			$row[] = $rows->shift;

			$row[] = $rows->time_scan;

			// switch ($rows->attend) :

			// 	case 'IN' :
			// 		$addClass1 = 'bg-green';
			// 		break;

			// 	case 'OUT':
			// 		$addClass1 = 'bg-red';
			// 		break;

			// endswitch;

			$row[] = '<div class="">' . $rows->attend . '</div>';

			if ($rows->attend_status == 'TERLAMBAT') {

			$row[] = '<div class="clr-red">' . $rows->attend_status . '</div>';

			} else {

			$row[] = $rows->attend_status;

			}

			$data[] = $row;

		endforeach;

		// Results
		$output = array(
						"data" => $data
					);

		echo json_encode($output);
		
	}
	// End of function server_side_data

	public function server_side_data_late() {

		// Set field order column
		$columnOrder = array('employee.name', 'department.name', 'division', 'time_scan', 'ansena_attend.attend', 'attend_status');

		// Set field search column
	    $columnSearch = array(
    						array(
    							'format' 	=> 'string',
    							'field' 	=> 'employee.name',
    							'type' 		=> 'search'
    						),
    						array(
    							'format' 	=> 'string',
    							'field' 	=> 'department.name',
    							'type' 		=> 'search'
    						),
    						array(
    							'format' 	=> 'string',
    							'field' 	=> 'division',
    							'type' 		=> 'search'
    						),
    						array(
    							'format' 	=> 'string',
    							'field' 	=> 'time_scan',
    							'type' 		=> 'singledate'
    						),
    						array(
    							'format' 	=> 'string',
    							'field' 	=> 'ansena_attend.attend',
    							'type' 		=> 'search'
    						),
    						array(
    							'format' 	=> 'string',
    							'field' 	=> 'attend_status',
    							'type' 		=> 'search'
    						)
	    				);
    	
    	// Set field ordering
    	$order = array('time_scan' => 'desc');

		$query = "SELECT ac_payroll_item.id, 
						 barcode, ac_payroll_item.name AS employee_name, 
						 ansena_department.name AS department, 
						 team,
						 is_pt,
						 ansena_division.division, 
						 DATE_FORMAT(time_scan, '%Y-%m-%d') AS date_scan,
						 DATE_FORMAT(time_scan, '%H:%i:%s') AS time_scan, 
						 ansena_attend.attend, 
						 attend_status
						 FROM ac_payroll_item
						 JOIN ansena_department ON ansena_department.id = ac_payroll_item.office
						 JOIN ansena_division ON ansena_division.id = ac_payroll_item.division
						 JOIN ansena_attend ON ansena_attend.ac_payroll_item_id = ac_payroll_item.id 
						 LEFT JOIN ansena_team_detail ON ansena_team_detail.ac_payroll_item_id = ac_payroll_item.id
						 LEFT JOIN ansena_team ON ansena_team.id = ansena_team_detail.ansena_team_id ";

   		$query .= $this->server_side_lib->individual_column_filtering_attend_late($columnSearch);

   		$query .= $this->server_side_lib->ordering($columnOrder, $order);

   		$attend = $query . $this->server_side_lib->limit();

   		$results = $this->db->query($attend)->result();

		$data = array();

		foreach ($results as $rows) :

			$row = array();

			$row[] = $rows->employee_name;

			if ($rows->is_pt == 1) {
				$department = 'PT. ' . str_replace('PT. ', '', $rows->department);
			} else {
				$department = str_replace('PT. ', '', $rows->department);
			}

			if ($rows->team != '') {
				$department = $department . ' (' . $rows->team . ')';
			}

			$row[] = $department;

			$row[] = $rows->division;

			$row[] = $rows->time_scan;

			switch ($rows->attend) :

				case 'IN' :
					$addClass1 = 'bg-green';
					break;

				case 'OUT':
					$addClass1 = 'bg-red';
					break;

			endswitch;

			$row[] = '<div class="' . $addClass1 . '">' . $rows->attend . '</div>';

			if ($rows->attend_status == 'TERLAMBAT') {

			$row[] = '<div class="clr-red">' . $rows->attend_status . '</div>';

			} elseif ($rows->attend_status == 'IJIN') {

			$row[] = '<div class="clr-fushia">' . $rows->attend_status . '</div>';

			} else {

			$row[] = $rows->attend_status;

			}

			$data[] = $row;

		endforeach;

		// Results
		$output = array(
						"draw" => $_POST['draw'],
						"data" => $data
					);

		echo json_encode($output);
		
	}
	// End of function server_side_data_late

	public function server_side_data_history_inout($id) {

		$query = $this->db->query("SELECT ansena_inout.id, date_inout, noted
										  FROM ansena_inout
										  JOIN ac_payroll_item ON ac_payroll_item.id = ansena_inout.ac_payroll_item_id
										  WHERE ac_payroll_item_id = '$id'
										  ORDER BY date_inout DESC");
		
		$data = array();

		foreach ($query->result() as $rows) :

			$row = array();

			$row[] = date_format(date_create($rows->date_inout), 'd M Y');

			$row[] = $rows->noted;

			$row[] = '<div class="btn btn-group">
							<a href="' . site_url('attend/print_barcode/' . $rows->id) . '" target="_blank" class="btn btn-info btn-xs"><i class="fa fa-print"></i></a>
							<a href="#" onclick="send_wa(' . $rows->id . ')" class="btn btn-primary btn-xs">Send Link</a>
						</div>';

			$data[] = $row;

		endforeach;

		// Results
		$output = array(
            			"recordsTotal" => $query->num_rows(),
            			"recordsFiltered" => 5,
						"data" => $data
					);

		echo json_encode($output);
	}
	// End of function server_side_data_history_inout

	public function server_side_data_list_request() {

		$query = $this->db->query("SELECT ansena_inout.id,
										  ac_payroll_item.name,
										  IF(is_pt = 1, CONCAT('PT. ', REPLACE(ansena_department.name, 'PT. ', '')), REPLACE(ansena_department.name, 'PT. ', '')) AS 'department',
										  team,
										  ansena_division.division,
										  ansena_inout.noted
										  FROM ansena_inout
										  JOIN ac_payroll_item ON ac_payroll_item.id = ansena_inout.ac_payroll_item_id
										  JOIN ansena_department ON ansena_department.id = ac_payroll_item.office
										  JOIN ansena_division ON ansena_division.id = ac_payroll_item.division
										  LEFT JOIN ansena_team_detail ON ansena_team_detail.ac_payroll_item_id = ac_payroll_item.id
    									  LEFT JOIN ansena_team ON ansena_team.id = ansena_team_detail.ansena_team_id
										  WHERE ansena_inout.is_request = 1
										  AND ansena_inout.status = 'REQUESTED'
										  AND DATE_FORMAT(ansena_inout.date_inout, '%Y-%m-%d') = DATE_FORMAT(NOW(), '%Y-%m-%d')
										  ORDER BY ansena_inout.created DESC");

		$data = array();

		foreach ($query->result() as $rows) :

			$row = array();

			$row[] = $rows->name;

			if ($rows->team == '') {
				$department = $rows->department;
			} else {
				$department = $rows->department . ' (' . $rows->team . ')';
			}

			$row[] = $department;

			$row[] = $rows->division;

			$row[] = $rows->noted;

			$row[] = '<div class="btn btn-group">
						<a href="#" onclick="sendWA(' . $rows->id . ')" class="btn btn-xs btn-primary btn-send">OK</a>
						<a href="#" onclick="cancel(' . $rows->id . ')" class="btn btn-xs btn-danger btn-cancel"><i class="fa fa-times-circle"></i></a>
					</div>';

			$data[] = $row;

		endforeach;

		// Results
		$output = array(
						"data" => $data
					);

		echo json_encode($output);
		
	}
	// End of function server_side_data_list_request

	public function server_side_data_list_request_send() {

		$query = $this->db->query("SELECT ansena_inout.id,
							              ac_payroll_item.name,
										  IF(is_pt = 1, CONCAT('PT. ', REPLACE(ansena_department.name, 'PT. ', '')), REPLACE(ansena_department.name, 'PT. ', '')) AS 'department',
										  team,
										  ansena_division.division,
										  ansena_inout.noted
										  FROM ansena_inout
										  JOIN ac_payroll_item ON ac_payroll_item.id = ansena_inout.ac_payroll_item_id
										  JOIN ansena_department ON ansena_department.id = ac_payroll_item.office
										  JOIN ansena_division ON ansena_division.id = ac_payroll_item.division
										  LEFT JOIN ansena_team_detail ON ansena_team_detail.ac_payroll_item_id = ac_payroll_item.id
    									  LEFT JOIN ansena_team ON ansena_team.id = ansena_team_detail.ansena_team_id
										  WHERE ansena_inout.is_request = 1
										  AND ansena_inout.status = 'SEND'
										  AND DATE_FORMAT(ansena_inout.date_inout, '%Y-%m-%d') = DATE_FORMAT(NOW(), '%Y-%m-%d')
										  ORDER BY ansena_inout.created DESC");

		$data = array();

		foreach ($query->result() as $rows) :

			$row = array();

			$row[] = $rows->name;

			if ($rows->team == '') {
				$department = $rows->department;
			} else {
				$department = $rows->department . ' (' . $rows->team . ')';
			}

			$row[] = $department;

			$row[] = $rows->division;

			$row[] = $rows->noted;

			$row[] = '<a href="#" onclick="cancel(' . $rows->id . ')" class="btn btn-xs btn-danger btn-cancel"><i class="fa fa-times-circle"></i></a>';

			$data[] = $row;

		endforeach;

		// Results
		$output = array(
						"data" => $data
					);

		echo json_encode($output);
		
	}
	// End of function server_side_data_list_request_send

	public function server_side_data_list_request_cancel() {

		$query = $this->db->query("SELECT ansena_inout.id,
							              ac_payroll_item.name,
										  IF(is_pt = 1, CONCAT('PT. ', REPLACE(ansena_department.name, 'PT. ', '')), REPLACE(ansena_department.name, 'PT. ', '')) AS 'department',
										  team,
										  ansena_division.division,
										  ansena_inout.noted
										  FROM ansena_inout
										  JOIN ac_payroll_item ON ac_payroll_item.id = ansena_inout.ac_payroll_item_id
										  JOIN ansena_department ON ansena_department.id = ac_payroll_item.office
										  JOIN ansena_division ON ansena_division.id = ac_payroll_item.division
										  LEFT JOIN ansena_team_detail ON ansena_team_detail.ac_payroll_item_id = ac_payroll_item.id
    									  LEFT JOIN ansena_team ON ansena_team.id = ansena_team_detail.ansena_team_id
										  WHERE ansena_inout.is_request = 1
										  AND ansena_inout.status = 'CANCEL'
										  AND DATE_FORMAT(ansena_inout.date_inout, '%Y-%m-%d') = DATE_FORMAT(NOW(), '%Y-%m-%d')
										  ORDER BY ansena_inout.created DESC");

		$data = array();

		foreach ($query->result() as $rows) :

			$row = array();

			$row[] = $rows->name;

			if ($rows->team == '') {
				$department = $rows->department;
			} else {
				$department = $rows->department . ' (' . $rows->team . ')';
			}

			$row[] = $department;

			$row[] = $rows->division;

			$row[] = $rows->noted;

			$data[] = $row;

		endforeach;

		// Results
		$output = array(
						"data" => $data
					);

		echo json_encode($output);
		
	}
	// End of function server_side_data_list_request_cancel

	function count_late() {

		$query = "SELECT id
						 FROM ansena_attend
						 WHERE DATE_FORMAT(time_scan, '%Y-%m-%d') = '" . $this->input->get('date') . "'
						 AND attend_status = 'TERLAMBAT'";

		$result = $this->db->query($query)->num_rows();

		echo $result;

	}
	// End of function count_late

	public function monthly_report_late($month = null) {

		if (! $this->session->userdata('ac_payroll_item_id')) {
			$this->session->set_flashdata('alert-error', 'Sesi telah berakhir');
			redirect('login');
		}

		if ($month == NULL) {
			$month = date('Y-m');
		}

		$query = $this->db->query("SELECT attend_date, detail
										  FROM ansena_attend_resume
										  WHERE DATE_FORMAT(attend_date, '%Y-%m') = '" . $month . "'
										  ORDER BY attend_date ASC")->result_array();

		$masterData = $this->db->query("SELECT ac_payroll_item.id, 
											ac_payroll_item.name,
											IF(is_pt = 1, CONCAT('PT. ', REPLACE(ansena_department.name, 'PT. ', '')), REPLACE(ansena_department.name, 'PT. ', '')) AS 'department',
											ansena_team.team,
											ansena_division.division
											FROM ac_payroll_item
											JOIN ansena_department ON ansena_department.id = ac_payroll_item.office
											JOIN ansena_division ON ansena_division.id = ac_payroll_item.division
											LEFT JOIN ansena_team_detail ON ansena_team_detail.ac_payroll_item_id = ac_payroll_item.id
											LEFT JOIN ansena_team ON ansena_team.id = ansena_team_detail.ansena_team_id
											WHERE is_active = 1
											AND DATE_FORMAT(date_join, '%Y-%m') <= '" . $month . "'
											AND barcode IS NOT NULL
											ORDER BY ac_payroll_item.name ASC")->result();

		$department = $this->db->query("SELECT CONCAT(IF(is_pt = 1, CONCAT('PT. ', REPLACE(name, 'PT. ', '')), REPLACE(name, 'PT. ', '')), ' (', team, ')') AS 'name',
															     CONCAT('t', ansena_team.id) AS 'id'
																 FROM ansena_team 
																 LEFT JOIN ansena_department ON ansena_department.id = ansena_team.dept_id 
																 AND progress != 0
																 UNION ALL 
																 SELECT IF(is_pt = 1, CONCAT('PT. ', REPLACE(name, 'PT. ', '')), REPLACE(name, 'PT. ', '')) AS 'name',
																 CONCAT('d', ansena_department.id) AS 'id'
																 FROM ansena_department 
																 LEFT OUTER JOIN ansena_team ON ansena_team.dept_id = ansena_department.id 
																 WHERE ansena_team.id IS NULL
																 AND progress != 0")->result();

		$warning = $this->db->query("SELECT id_item,
											MAX(id_berkas) AS 'id_berkas'
											FROM ac_employee_warning
											WHERE id_berkas LIKE '%1-4-%'
											AND DATE_FORMAT(date_start, '%Y-%m') = '" . $month . "'
											GROUP BY id_item")->result();

		$arrayWarning = array();
		foreach ($warning as $row) :
			$arrayWarning['i' . $row->id_item] = $row->id_berkas;
		endforeach;

		$attr = array(
						'period' 		=> date('M Y', strtotime($month)),
						'attendData' 	=> $query,
						'masterData' 	=> $masterData,
						'arrayWaning'	=> $arrayWarning,
						'departmentMaster'	=> $department
					);

		if (count($query) == 0 || count($masterData) == 0) {
			echo 'error-null';
		} else {
			$this->load->view('attend/layouts/header');
			$this->load->view('attend/layouts/navbar');
			$this->load->view('attend/monthly-report-late/navbar-sub');
			$this->load->view('attend/layouts/content-wrapper');
			$this->load->view('attend/monthly-report-late/monthly-report-result-late', $attr);
			$this->load->view('attend/layouts/footer');
		}

	}
	// End of function monthly_report_late

	public function monthly_report_late_dept() {

		if (! $this->session->userdata('ac_payroll_item_id')) {
			$this->session->set_flashdata('alert-error', 'Sesi telah berakhir');
			redirect('login');
		}

		$value = $this->input->post('value');

		$explode = explode('_', $value);
		$department = $explode[0];
		$date 	 = $explode[1];

		if (substr($department, 0, 1) == 'd') {

			$dept_id = preg_replace('/[^0-9]/', '', $department);

			$query = $this->db->query("SELECT ansena_attend.id
												FROM ansena_attend 
												JOIN ac_payroll_item ON ac_payroll_item.id = ansena_attend.ac_payroll_item_id
												WHERE attend = 'IN' AND attend_status = 'TERLAMBAT'
												AND DATE_FORMAT(time_scan, '%Y-%m-%d') = '" . $date . "'
												AND office = " . $dept_id);

			$pembanding = $this->db->query("SELECT ansena_attend.id
												FROM ansena_attend 
												JOIN ac_payroll_item ON ac_payroll_item.id = ansena_attend.ac_payroll_item_id
												WHERE attend = 'IN' AND attend_status = 'OK'
												AND DATE_FORMAT(time_scan, '%Y-%m-%d') = '" . $date . "'
												AND office = " . $dept_id);

		} else {

			$dept_id = preg_replace('/[^0-9]/', '', $department);

			$query = $this->db->query("SELECT ansena_attend.id
											FROM ansena_attend 
											JOIN ac_payroll_item ON ac_payroll_item.id = ansena_attend.ac_payroll_item_id
											JOIN ansena_team_detail ON ansena_team_detail.ac_payroll_item_id = ac_payroll_item.id
											WHERE ansena_attend.attend = 'IN' AND attend_status = 'TERLAMBAT'
											AND DATE_FORMAT(time_scan, '%Y-%m-%d') = '" . $date . "'
											AND ansena_team_id = " . $dept_id);

			$pembanding = $this->db->query("SELECT ansena_attend.id
											FROM ansena_attend 
											JOIN ac_payroll_item ON ac_payroll_item.id = ansena_attend.ac_payroll_item_id
											JOIN ansena_team_detail ON ansena_team_detail.ac_payroll_item_id = ac_payroll_item.id
											WHERE ansena_attend.attend = 'IN' AND attend_status = 'OK'
											AND DATE_FORMAT(time_scan, '%Y-%m-%d') = '" . $date . "'
											AND ansena_team_id = " . $dept_id);

		}

		if ($query->num_rows() > 0) {
			$percent = round(round($query->num_rows()/($query->num_rows()+$pembanding->num_rows()), 2)*100);
		} else {
			$percent = 0;
		}

		echo $percent;

	}
	// End of function monthly_report_late_dept

	public function monthly_report_late_dept_total() {

		if (! $this->session->userdata('ac_payroll_item_id')) {
			$this->session->set_flashdata('alert-error', 'Sesi telah berakhir');
			redirect('login');
		}

		$value = $this->input->post('value');

		$explode = explode('_', $value);
		$department = $explode[0];
		$date 	 = $explode[1];

		if (substr($department, 0, 1) == 'd') {

			$dept_id = preg_replace('/[^0-9]/', '', $department);

			$query = $this->db->query("SELECT ansena_attend.id
												FROM ansena_attend 
												JOIN ac_payroll_item ON ac_payroll_item.id = ansena_attend.ac_payroll_item_id
												WHERE attend = 'IN' AND attend_status = 'TERLAMBAT'
												AND DATE_FORMAT(time_scan, '%Y-%m') = '" . $date . "'
												AND office = " . $dept_id);

			$pembanding = $this->db->query("SELECT ansena_attend.id
												FROM ansena_attend 
												JOIN ac_payroll_item ON ac_payroll_item.id = ansena_attend.ac_payroll_item_id
												WHERE attend = 'IN' AND attend_status = 'OK'
												AND DATE_FORMAT(time_scan, '%Y-%m') = '" . $date . "'
												AND office = " . $dept_id);

		} else {

			$dept_id = preg_replace('/[^0-9]/', '', $department);

			$query = $this->db->query("SELECT ansena_attend.id
											FROM ansena_attend 
											JOIN ac_payroll_item ON ac_payroll_item.id = ansena_attend.ac_payroll_item_id
											JOIN ansena_team_detail ON ansena_team_detail.ac_payroll_item_id = ac_payroll_item.id
											WHERE ansena_attend.attend = 'IN' AND attend_status = 'TERLAMBAT'
											AND DATE_FORMAT(time_scan, '%Y-%m') = '" . $date . "'
											AND ansena_team_id = " . $dept_id);

			$pembanding = $this->db->query("SELECT ansena_attend.id
											FROM ansena_attend 
											JOIN ac_payroll_item ON ac_payroll_item.id = ansena_attend.ac_payroll_item_id
											JOIN ansena_team_detail ON ansena_team_detail.ac_payroll_item_id = ac_payroll_item.id
											WHERE ansena_attend.attend = 'IN' AND attend_status = 'OK'
											AND DATE_FORMAT(time_scan, '%Y-%m') = '" . $date . "'
											AND ansena_team_id = " . $dept_id);

		}

		if ($query->num_rows() > 0) {
			$percent = round(round($query->num_rows()/($query->num_rows()+$pembanding->num_rows()), 2)*100);
		} else {
			$percent = 0;
		}

		echo $percent;

	}
	// End of function monthly_report_late_dept_total

	public function feeling_today() {

		if (! $this->session->userdata('ac_payroll_item_id')) {
			$this->session->set_flashdata('alert-error', 'Sesi telah berakhir');
			redirect('login');
		}
		
		$sintax = $this->restrict_lib->query_access();

		$attr = array(
						'department' => $this->db->query($sintax)->result()
		);

		$this->load->view('attend/layouts/header');
		$this->load->view('attend/layouts/navbar');
		$this->load->view('attend/feeling-today/navbar-sub');
		$this->load->view('attend/layouts/content-wrapper');
		$this->load->view('attend/feeling-today/feeling-today', $attr);
		$this->load->view('attend/layouts/footer');

	}
	// End of function feeling_today

	public function feeling_today_list() {

		if (! $this->session->userdata('ac_payroll_item_id')) {
			$this->session->set_flashdata('alert-error', 'Sesi telah berakhir');
			redirect('login');
		}

		$department = $this->input->get('department');
		$date_input = $this->input->get('date_input');

		if (substr($department, 0, 1) == 'd') {

			$dept = preg_replace('/[^0-9]/', '', $department);

			$query = $this->db->query("SELECT ac_payroll_item.name,
											IF(is_pt = 1, CONCAT('PT. ', REPLACE(ansena_department.name, 'PT. ', '')), REPLACE(ansena_department.name, 'PT. ', '')) AS 	'department',
											ansena_division.division,
											MAX(IF(ansena_attend.attend = 'IN', mood, NULL)) AS 'mood_in',
											MAX(IF(ansena_attend.attend = 'OUT', mood,  NULL)) AS 'mood_out'
											FROM ac_payroll_item
											JOIN ansena_attend ON ansena_attend.ac_payroll_item_id = ac_payroll_item.id
											JOIN ansena_department ON ansena_department.id = ac_payroll_item.office
						 					JOIN ansena_division ON ansena_division.id = ac_payroll_item.division
											WHERE office = " . $dept . "
											AND DATE_FORMAT(time_scan, '%Y-%m-%d') = '" . $date_input . "'
											AND (ansena_attend.attend = 'IN' OR ansena_attend.attend = 'OUT')
											GROUP BY ac_payroll_item_id
											ORDER BY ac_payroll_item.name");

		} else {

			$dept = preg_replace('/[^0-9]/', '', $department);

			$query = $this->db->query("SELECT ac_payroll_item.name,
											IF(is_pt = 1, CONCAT('PT. ', REPLACE(ansena_department.name, 'PT. ', '')), REPLACE(ansena_department.name, 'PT. ', '')) AS 	'department',
											team,
											ansena_division.division,
											MAX(IF(ansena_attend.attend = 'IN', mood, NULL)) AS 'mood_in',
											MAX(IF(ansena_attend.attend = 'OUT', mood,  NULL)) AS 'mood_out'
											FROM ac_payroll_item
											JOIN ansena_attend ON ansena_attend.ac_payroll_item_id = ac_payroll_item.id
											JOIN ansena_department ON ansena_department.id = ac_payroll_item.office
						 					JOIN ansena_division ON ansena_division.id = ac_payroll_item.division
											JOIN ansena_team_detail ON ansena_team_detail.ac_payroll_item_id = ac_payroll_item.id
											JOIN ansena_team ON ansena_team.id = ansena_team_detail.ansena_team_id
											WHERE ansena_team.id = " . $dept . "
											AND DATE_FORMAT(time_scan, '%Y-%m-%d') = '" . $date_input . "'
											AND (ansena_attend.attend = 'IN' OR ansena_attend.attend = 'OUT')
											GROUP BY ac_payroll_item.id
											ORDER BY ac_payroll_item.name");
		}

		$attr = array(
						'department' => $department,
						'date_input' => $date_input,
						'result'	=> $query->result()
					);

		$this->load->view('attend/feeling-today/feeling-today-list', $attr);

	}
	// End of function feeling_today_list

	public function total_mood() {

		$mood = $this->input->get('mood_id');
		$department = $this->input->get('department');
		$date_input = $this->input->get('date_input');

		if (substr($department, 0, 1) == 'd') {

			$dept = preg_replace('/[^0-9]/', '', $department);

			$query = $this->db->query("SELECT ansena_attend.id
											FROM ansena_attend
											JOIN ac_payroll_item ON ac_payroll_item.id = ansena_attend.ac_payroll_item_id
											WHERE DATE_FORMAT(time_scan, '%Y-%m-%d') = '" . $date_input . "'
											AND office = " . $dept . "
											AND mood = " . $mood . "
											AND (ansena_attend.attend = 'IN' OR ansena_attend.attend = 'OUT')
											GROUP BY ac_payroll_item.id, ansena_attend.attend");

			$pembanding = $this->db->query("SELECT ansena_attend.id
											FROM ansena_attend
											JOIN ac_payroll_item ON ac_payroll_item.id = ansena_attend.ac_payroll_item_id
											WHERE DATE_FORMAT(time_scan, '%Y-%m-%d') = '" . $date_input . "'
											AND office = " . $dept . "
											AND mood IS NOT NULL
											AND (ansena_attend.attend = 'IN' OR ansena_attend.attend = 'OUT')
											GROUP BY ac_payroll_item.id, ansena_attend.attend");
											
		} else {

			$dept = preg_replace('/[^0-9]/', '', $department);

			$query = $this->db->query("SELECT ansena_attend.id
											FROM ansena_attend
											JOIN ansena_team_detail ON ansena_team_detail.ac_payroll_item_id = ansena_attend.ac_payroll_item_id
											WHERE DATE_FORMAT(time_scan, '%Y-%m-%d') = '" . $date_input . "'
											AND ansena_team_id = " . $dept . "
											AND mood = " . $mood . "
											AND (ansena_attend.attend = 'IN' OR ansena_attend.attend = 'OUT')
											GROUP BY ansena_attend.ac_payroll_item_id, ansena_attend.attend");

			$pembanding = $this->db->query("SELECT ansena_attend.id
											FROM ansena_attend
											JOIN ansena_team_detail ON ansena_team_detail.ac_payroll_item_id = ansena_attend.ac_payroll_item_id
											WHERE DATE_FORMAT(time_scan, '%Y-%m-%d') = '" . $date_input . "'
											AND ansena_team_id = " . $dept . "
											AND mood IS NOT NULL
											AND (ansena_attend.attend = 'IN' OR ansena_attend.attend = 'OUT')
											GROUP BY ansena_attend.ac_payroll_item_id, ansena_attend.attend");

		}

		if ($query->num_rows() == 0) {
			$total_mood['number'] = 0;
			$total_mood['persent'] = 0;
		} else {
			$total_mood['number'] = $query->num_rows();
			$total_mood['persent'] = round($query->num_rows()/$pembanding->num_rows()*100, 2);
		}

		$response = $total_mood['persent'] . '<small>%</small> (' . $total_mood['number'] . ')';

		echo $response;

	}
	// End of function total_mood

	public function employee_performance() {

		if (! $this->session->userdata('ac_payroll_item_id')) {
			$this->session->set_flashdata('alert-error', 'Sesi telah berakhir');
			redirect('login');
		}

		$sintax = $this->restrict_lib->query_access();

		$attr = array(
						'department' => $this->db->query($sintax)->result()
		);

		$this->load->view('attend/layouts/header');
		$this->load->view('attend/layouts/navbar');
		$this->load->view('attend/employee-performance/navbar-sub');
		$this->load->view('attend/layouts/content-wrapper');
		$this->load->view('attend/employee-performance/index', $attr);
		$this->load->view('attend/layouts/footer');

	}
	// End of function employee_performance

	public function employee_performance_result() {

		if (! $this->session->userdata('ac_payroll_item_id')) {
			$this->session->set_flashdata('alert-error', 'Sesi telah berakhir');
			redirect('login');
		}

		$month = $this->input->post('month');
		$department = $this->input->post('department');

		$attendData = $this->db->query("SELECT attend_date, detail
										  FROM ansena_attend_resume
										  WHERE DATE_FORMAT(attend_date, '%Y-%m') = '" . $month . "'
										  ORDER BY attend_date ASC")->result_array();

		if (substr($department, 0, 1) == 'd') {

			$dept_id = preg_replace('/[^0-9]/', '', $department);

			$masterData = $this->db->query("SELECT ac_payroll_item.id, name, ansena_division.division
												FROM ac_payroll_item
												JOIN ansena_division ON ansena_division.id = ac_payroll_item.division
												WHERE is_active = 1
												AND office = '" . $dept_id. "'
												AND DATE_FORMAT(date_join, '%Y-%m') <= '" . $this->input->post('month') . "'
												AND barcode IS NOT NULL
												ORDER BY name ASC")->result();

		} else {

			$dept_id = preg_replace('/[^0-9]/', '', $department);

			$masterData = $this->db->query("SELECT ac_payroll_item.id, name, ansena_division.division
												FROM ac_payroll_item
												JOIN ansena_team_detail ON ansena_team_detail.ac_payroll_item_id = ac_payroll_item.id
												JOIN ansena_division ON ansena_division.id = ac_payroll_item.division
												WHERE is_active = 1
												AND ansena_team_detail.ansena_team_id = '" . $dept_id . "'
												AND DATE_FORMAT(date_join, '%Y-%m') <= '" . $this->input->post('month') . "'
												AND barcode IS NOT NULL
												ORDER BY name ASC")->result();

		}

		$attr = array(
						'attendData'	=> $attendData,
						'masterData'	=> $masterData,
						'month'			=> $month
		);

		$this->load->view('attend/employee-performance/result', $attr);

	}
	// End of function employee_performance_result

	public function get_mood_monthly() {

		if (! $this->session->userdata('ac_payroll_item_id')) {
			$this->session->set_flashdata('alert-error', 'Sesi telah berakhir');
			redirect('login');
		}

		$id = $this->input->post('id');
		$month = $this->input->post('month');

		$mood = 1;

		$query = $this->db->query("SELECT ansena_attend.id
											FROM ansena_attend
											WHERE DATE_FORMAT(time_scan, '%Y-%m') = '" . $month . "'
											AND ansena_attend.ac_payroll_item_id = " . $id . "
											AND mood = " . $mood . "
											AND (ansena_attend.attend = 'IN' OR ansena_attend.attend = 'OUT')
											GROUP BY ansena_attend.ac_payroll_item_id, ansena_attend.attend");

		$pembanding = $this->db->query("SELECT ansena_attend.id
										FROM ansena_attend
										WHERE DATE_FORMAT(time_scan, '%Y-%m') = '" . $month . "'
										AND ansena_attend.ac_payroll_item_id = " . $id . "
										AND mood IS NOT NULL
										AND (ansena_attend.attend = 'IN' OR ansena_attend.attend = 'OUT')
										GROUP BY ansena_attend.ac_payroll_item_id, ansena_attend.attend");

		if ($query->num_rows() == 0) {
			$total_mood = 0;
		} else {
			$total_mood = round($query->num_rows()/$pembanding->num_rows()*100, 2);
		}

		$response = $total_mood;

		echo $response;

	}
	// End of function get_mood_monthly

	public function load_modal_sign_out() {
		$this->load->view('attend/layouts/modal-sign-out');
	}
	// End of function load_modal_sign_out

	public function logout() {

		// Destroy session
		$this->session->sess_destroy();

		redirect('login?destroy=1');
	}
	// End of function logout

}
/* End of file Attend.php */
/* Location: ./application/controllers/Attend.php */

