<?php
defined('BASEPATH') OR exit('No direct script access allowed');
date_default_timezone_set('Asia/Jakarta');

/*
 * Class Attend_custom
 */
class Attend_custom extends CI_Controller {

	function __construct() {
		parent::__construct();

		$this->load->library('server_side_lib');

	}

	public function form_new_config() {

		$date = date('Y-m-d', strtotime('-1 day'));

		$attr = array(
						'department' => $this->db->query("SELECT CONCAT(IF(is_pt = 1, CONCAT('PT. ', REPLACE(name, 'PT. ', '')), REPLACE(name, 'PT. ', '')), ' (', team, ')') AS 'name',
															     CONCAT('t', ansena_team.id) AS 'id'
																 FROM ansena_team 
																 LEFT JOIN ansena_department ON ansena_department.id = ansena_team.dept_id 
																 UNION ALL 
																 SELECT IF(is_pt = 1, CONCAT('PT. ', REPLACE(name, 'PT. ', '')), REPLACE(name, 'PT. ', '')) AS 'name',
																 CONCAT('d', ansena_department.id) AS 'id'
																 FROM ansena_department 
																 LEFT OUTER JOIN ansena_team ON ansena_team.dept_id = ansena_department.id 
																 WHERE ansena_team.id IS NULL")->result(),
						'event'		=> $this->db->query("SELECT id, title
																FROM events
																WHERE event_date = '" . $date . "'")->result(),
						'date' => $date
					);

		$this->load->view('attend/layouts/header');
		$this->load->view('attend/layouts/navbar');
		$this->load->view('attend/attend-custom/navbar-sub');
		$this->load->view('attend/layouts/content-wrapper');
		$this->load->view('attend/attend-custom/form-new-config', $attr);
		$this->load->view('attend/layouts/footer');
		
	}
	// End of function form_new_config

	public function server_side_data() {

		$department = $this->db->query("SELECT id, IF(is_pt = 1, CONCAT('PT. ', REPLACE(name, 'PT. ', '')), REPLACE(name, 'PT. ', '')) AS 'name'
											   FROM ansena_department
											   ORDER BY sort ASC")->result();

		foreach ($department as $row) :
			$arrayDepartment['d' . $row->id] = $row->name;
		endforeach;

		$team = $this->db->query("SELECT ansena_team.id, team, IF(is_pt = 1, CONCAT('PT. ', REPLACE(name, 'PT. ', '')), REPLACE(name, 'PT. ', '')) AS 'name'
										 FROM ansena_team
										 JOIN ansena_department ON ansena_department.id = ansena_team.dept_id
										 ORDER BY team ASC")->result();

		foreach ($team as $row) :
			$arrayTeam['t' . $row->id] = $row->name . ' (' . $row->team . ')';
		endforeach;

		$query = "SELECT id, ref_id, detail, date_range, time_attend, created_time
				  FROM attend_custom
				  WHERE SUBSTRING(ref_id, 1, 1) != 'x'
				  ORDER BY created_time DESC";

		$result = $this->db->query($query)->result();

		$data = array();
		foreach ($result as $rows) :
			
			$row = array();

			if (isset($arrayDepartment[$rows->ref_id])) {
				$row[] = $arrayDepartment[$rows->ref_id];
			} elseif (isset($arrayTeam[$rows->ref_id])) {
				$row[] = $arrayTeam[$rows->ref_id];
			}

			$date_range = $rows->date_range;
			$explode = explode(' - ', $date_range);

			if ($explode[0] == $explode[1]) {
				$row[] = date('d M Y', strtotime($explode[0]));
			} else {
				$row[] = date('d M Y', strtotime($explode[0])) . ' - ' . date('d M Y', strtotime($explode[1])); 
			}

			$row[] = $rows->time_attend;

			$row[] = date('d M Y H:i:s', strtotime($rows->created_time));

			$btnDelete = '<a href="javascript:void(0)" id="btn-confirm-delete" key="' . $rows->id . '" class="btn btn-sm btn-outline-danger"><i class="fa fa-trash"></i></a>';

			$row[] = $btnDelete;

			$data[] = $row;

		endforeach;

		$output = array(
						'data' => $data
					);

		echo json_encode($output);

	}
	// End of function server_side_data

	public function server_side_data_event() {

		$events = $this->db->query("SELECT id,
										   title
										   FROM events")->result();

		foreach ($events as $row) :
			$arrayEvent['x' . $row->id] = $row->title;
		endforeach;

		$query = "SELECT id, ref_id, detail, date_range, time_attend, created_time
				  FROM attend_custom
				  WHERE SUBSTRING(ref_id, 1, 1) = 'x'
				  ORDER BY created_time DESC";

		$result = $this->db->query($query)->result();

		$data = array();
		foreach ($result as $rows) :
			
			$row = array();

			if (isset($arrayEvent[$rows->ref_id])) {
				$row[] = $arrayEvent[$rows->ref_id];
			}

			$date_range = $rows->date_range;
			$explode = explode(' - ', $date_range);

			if ($explode[0] == $explode[1]) {
				$row[] = date('d M Y', strtotime($explode[0]));
			} else {
				$row[] = date('d M Y', strtotime($explode[0])) . ' - ' . date('d M Y', strtotime($explode[1])); 
			}

			$row[] = $rows->time_attend;

			$row[] = date('d M Y H:i:s', strtotime($rows->created_time));

			$btnDelete = '<a href="javascript:void(0)" id="btn-confirm-delete" key="' . $rows->id . '" class="btn btn-sm btn-outline-danger"><i class="fa fa-trash"></i></a>';

			$row[] = $btnDelete;

			$data[] = $row;

		endforeach;

		$output = array(
						'data' => $data
					);

		echo json_encode($output);

	}
	// End of function server_side_data_event

	/**
	 * @param post => ref_id
	 * @param post => custom_date
	 * @param post => custom_time
	 */
	public function save_data() {

		if (empty($this->input->post('ref_id')) ||
			empty($this->input->post('custom_date')) ||
			empty($this->input->post('custom_time'))) {

			echo 'error-null';
		} else {
			
			$explode = explode(' - ', $this->input->post('custom_date'));

			$date_start 	= strtotime($explode[0]);
			$date_finish	= strtotime($explode[1]);

			$date_diff		= $date_finish - $date_start;
			$interval 		= round($date_diff/(60 * 60 * 24)) + 1; 

			for ($i =0; $i < $interval; $i++) {
				$date_now = date('Y-m-d', strtotime('+' . $i . ' day', $date_start));
				$detail[$date_now] = date('H:i:s', strtotime($this->input->post('custom_time')));	
			}

			$data = array(
							'ref_id' 		=> $this->input->post('ref_id'),
							'date_range'	=> $this->input->post('custom_date'),
							'time_attend'	=> date('H:i:s', strtotime($this->input->post('custom_time'))),
							'detail'		=> json_encode($detail),
							'created_time' 	=> date('Y-m-d H:i:s')
			);

			$this->db->insert('attend_custom', $data);

			echo 'success';

		}

	}
	// End of function save_data

	/**
	 * @param post => ref_id
	 * @param post => custom_date
	 * @param post => custom_time
	 */
	public function save_data_event() {

		if (empty($this->input->post('event_id')) ||
			empty($this->input->post('custom_time'))) {

			echo 'error-null';
		} else {
			$key = 'x' . $this->input->post('event_id');
			$query = $this->db->query("SELECT id FROM attend_custom WHERE ref_id = '" . $key . "'");

			if ($query->num_rows() > 0) {
				echo 'error-duplicate';
			} else {

				$date_now = date('Y-m-d');
				$detail[$date_now] = date('H:i:s', strtotime($this->input->post('custom_time')));	

				$data = array(
								'ref_id' 		=> 'x' . $this->input->post('event_id'),
								'date_range'	=> date('m/d/Y') . ' - ' . date('m/d/Y'),
								'time_attend'	=> date('H:i:s', strtotime($this->input->post('custom_time'))),
								'detail'		=> json_encode($detail),
								'created_time' 	=> date('Y-m-d H:i:s')
				);

				$this->db->insert('attend_custom', $data);

				echo 'success';

			}

		}

	}
	// End of function save_data_event

	public function delete_data() {

		$this->db->where('id', $this->input->post('id'));
		$this->db->delete('attend_custom');

		echo 'success';

	}
	// End of function delete_data

}
/* End of file Attend_custom.php */
/* Location: ./application/controllers/Attend_custom.php */
