<?php
defined('BASEPATH') OR exit('No direct script access allowed');
date_default_timezone_set('Asia/Jakarta');

/*
 * Class Attend_event
 */
class Attend_event extends CI_Controller {

    public function index() {

        $sintax = $this->restrict_lib->query_access();

		$attr = array(
						'department' => $this->db->query($sintax)->result(),
                        'events'    => $this->db->query("SELECT id, title
                                                             FROM events
                                                             WHERE DATE_FORMAT(event_date, '%Y-%m') = DATE_FORMAT(NOW(), '%Y-%m')
                                                             ORDER BY event_date DESC")->result()
                    );

        $this->load->view('attend/layouts/header');
		$this->load->view('attend/layouts/navbar');
		$this->load->view('attend/attend-event/navbar-sub');
		$this->load->view('attend/layouts/content-wrapper');
		$this->load->view('attend/attend-event/index', $attr);
		$this->load->view('attend/layouts/footer');
		
    }

    public function display_event() {
        
        $periode = $this->input->post('periode');

        $events = $this->db->query("SELECT id, title
                                          FROM events
                                          WHERE DATE_FORMAT(event_date, '%Y-%m') = '" . $periode . "'")->result();

        $html = '<select class="form-control" id="event" name="event">';
        $html .= '<option value="" disabled selected>Pilih Event</option>';
        foreach ($events as $row) :
            $html .= '<option value="' . $row->id . '">' . $row->title . '</option>';
        endforeach;
        $html .= '</select>';

        echo $html;

    }
    // End of function display_event

    public function load_data() {

        $department = $this->input->post('department');

        if (substr($department, 0, 1) == 'x') {

            $query = "SELECT ac_payroll_item.id,
							ac_payroll_item.name AS employee_name, 
							is_pt,
                            gender,
							IF(is_pt = 1, CONCAT('PT. ', REPLACE(ansena_department.name, 'PT. ', '')), REPLACE(ansena_department.name, 'PT. ', '')) AS 'department',
							ansena_division.division, 
							ansena_team.team,
                            event_date,
                            event_time,
							IF(time_scan IS NOT NULL, MIN(time_scan), NULL) AS 'time_in',
							IF(time_scan IS NOT NULL, MAX(time_scan), NULL) AS 'time_out',
							IF(time_scan IS NOT NULL, TIMEDIFF(MAX(time_scan), MIN(time_scan)), NULL) AS 'time_diff',
							MAX(IF(events_attend.attend = 'IN', review_events, 0)) AS 'review_in',
							MAX(IF(events_attend.attend = 'OUT', review_events, 0)) AS 'review_out'
							FROM ac_payroll_item
							LEFT JOIN events_attend ON events_attend.ac_payroll_item_id = ac_payroll_item.id AND event_id = " . $this->input->post('event_id') . "
                            LEFT JOIN events ON events.id = events_attend.event_id
							JOIN ansena_department ON ansena_department.id = ac_payroll_item.office
							JOIN ansena_division ON ansena_division.id = ac_payroll_item.division
							LEFT JOIN ansena_team_detail ON ansena_team_detail.ac_payroll_item_id = ac_payroll_item.id
							LEFT JOIN ansena_team ON ansena_team.id = ansena_team_detail.ansena_team_id
                            WHERE is_active = 1
                            AND barcode IS NOT NULL
                            AND time_scan IS NOT NULL
							GROUP BY ac_payroll_item.id
                            ORDER BY time_scan, ansena_department.name, ansena_team.team, ac_payroll_item.name ASC";
                            
            $query_2 = "SELECT ac_payroll_item.id,
							ac_payroll_item.name AS employee_name, 
							is_pt,
                            gender,
							IF(is_pt = 1, CONCAT('PT. ', REPLACE(ansena_department.name, 'PT. ', '')), REPLACE(ansena_department.name, 'PT. ', '')) AS 'department',
							ansena_division.division, 
							ansena_team.team,
                            event_date,
                            event_time,
							IF(events_attend.time_scan IS NOT NULL, MIN(events_attend.time_scan), NULL) AS 'time_in',
							IF(events_attend.time_scan IS NOT NULL, MAX(events_attend.time_scan), NULL) AS 'time_out',
							IF(events_attend.time_scan IS NOT NULL, TIMEDIFF(MAX(events_attend.time_scan), MIN(events_attend.time_scan)), NULL) AS 'time_diff',
							MAX(IF(events_attend.attend = 'IN', review_events, 0)) AS 'review_in',
							MAX(IF(events_attend.attend = 'OUT', review_events, 0)) AS 'review_out',
                            ansena_attend.attend
							FROM ac_payroll_item
							LEFT JOIN events_attend ON events_attend.ac_payroll_item_id = ac_payroll_item.id AND event_id = " . $this->input->post('event_id') . "
                            RIGHT JOIN events ON events.id = " . $this->input->post('event_id') . "
							JOIN ansena_department ON ansena_department.id = ac_payroll_item.office
							JOIN ansena_division ON ansena_division.id = ac_payroll_item.division
							LEFT JOIN ansena_team_detail ON ansena_team_detail.ac_payroll_item_id = ac_payroll_item.id
                            LEFT JOIN ansena_team ON ansena_team.id = ansena_team_detail.ansena_team_id
                            LEFT JOIN ansena_attend ON ansena_attend.ac_payroll_item_id = ac_payroll_item.id AND ansena_attend.attend != 'OUT' AND DATE_FORMAT(ansena_attend.time_scan, '%Y-%m-%d') = event_date
                            WHERE is_active = 1
                            AND barcode IS NOT NULL
                            AND events_attend.time_scan IS NULL
							GROUP BY ac_payroll_item.id
                            ORDER BY events_attend.time_scan, ansena_department.name, ansena_team.team, ac_payroll_item.name ASC";

            $department = $this->db->query("SELECT CONCAT(IF(is_pt = 1, CONCAT('PT. ', REPLACE(name, 'PT. ', '')), REPLACE(name, 'PT. ', '')), ' (', team, ')') AS 'name',
															     CONCAT('t', ansena_team.id) AS 'id'
																 FROM ansena_team 
																 LEFT JOIN ansena_department ON ansena_department.id = ansena_team.dept_id 
																 UNION ALL 
																 SELECT IF(is_pt = 1, CONCAT('PT. ', REPLACE(name, 'PT. ', '')), REPLACE(name, 'PT. ', '')) AS 'name',
																 CONCAT('d', ansena_department.id) AS 'id'
																 FROM ansena_department 
																 LEFT OUTER JOIN ansena_team ON ansena_team.dept_id = ansena_department.id 
																 WHERE ansena_team.id IS NULL")->result();

        } elseif (substr($department, 0, 1) == 'd') {

            $dept_id = preg_replace('/[^0-9]/', '', $department);

			$query = "SELECT ac_payroll_item.id,
                            ac_payroll_item.name AS employee_name, 
                            is_pt,
                            gender,
                            IF(is_pt = 1, CONCAT('PT. ', REPLACE(ansena_department.name, 'PT. ', '')), REPLACE(ansena_department.name, 'PT. ', '')) AS 'department',
                            ansena_division.division, 
                            ansena_team.team,
                            event_date,
                            event_time,
                            IF(time_scan IS NOT NULL, MIN(time_scan), NULL) AS 'time_in',
                            IF(time_scan IS NOT NULL, MAX(time_scan), NULL) AS 'time_out',
                            IF(time_scan IS NOT NULL, TIMEDIFF(MAX(time_scan), MIN(time_scan)), NULL) AS 'time_diff',
                            MAX(IF(events_attend.attend = 'IN', review_events, 0)) AS 'review_in',
                            MAX(IF(events_attend.attend = 'OUT', review_events, 0)) AS 'review_out'
                            FROM ac_payroll_item
                            LEFT JOIN events_attend ON events_attend.ac_payroll_item_id = ac_payroll_item.id AND event_id = " . $this->input->post('event_id') . "
                            LEFT JOIN events ON events.id = events_attend.event_id
                            JOIN ansena_department ON ansena_department.id = ac_payroll_item.office
                            JOIN ansena_division ON ansena_division.id = ac_payroll_item.division
                            LEFT JOIN ansena_team_detail ON ansena_team_detail.ac_payroll_item_id = ac_payroll_item.id
                            LEFT JOIN ansena_team ON ansena_team.id = ansena_team_detail.ansena_team_id
                            WHERE is_active = 1
                            AND barcode IS NOT NULL
                            AND time_scan IS NOT NULL
                            AND office = " . $dept_id . "
                            GROUP BY ac_payroll_item.id
                            ORDER BY ac_payroll_item.name ASC";

            $query_2 = "SELECT ac_payroll_item.id,
                                ac_payroll_item.name AS employee_name, 
                                is_pt,
                                gender,
                                IF(is_pt = 1, CONCAT('PT. ', REPLACE(ansena_department.name, 'PT. ', '')), REPLACE(ansena_department.name, 'PT. ', '')) AS 'department',
                                ansena_division.division, 
                                ansena_team.team,
                                event_date,
                                event_time,
                                IF(events_attend.time_scan IS NOT NULL, MIN(events_attend.time_scan), NULL) AS 'time_in',
                                IF(events_attend.time_scan IS NOT NULL, MAX(events_attend.time_scan), NULL) AS 'time_out',
                                IF(events_attend.time_scan IS NOT NULL, TIMEDIFF(MAX(events_attend.time_scan), MIN(events_attend.time_scan)), NULL) AS 'time_diff',
                                MAX(IF(events_attend.attend = 'IN', review_events, 0)) AS 'review_in',
                                MAX(IF(events_attend.attend = 'OUT', review_events, 0)) AS 'review_out',
                                ansena_attend.attend
                                FROM ac_payroll_item
                                LEFT JOIN events_attend ON events_attend.ac_payroll_item_id = ac_payroll_item.id AND event_id = " . $this->input->post('event_id') . "
                                RIGHT JOIN events ON events.id = " . $this->input->post('event_id') . "
                                JOIN ansena_department ON ansena_department.id = ac_payroll_item.office
                                JOIN ansena_division ON ansena_division.id = ac_payroll_item.division
                                LEFT JOIN ansena_team_detail ON ansena_team_detail.ac_payroll_item_id = ac_payroll_item.id
                                LEFT JOIN ansena_team ON ansena_team.id = ansena_team_detail.ansena_team_id
                                LEFT JOIN ansena_attend ON ansena_attend.ac_payroll_item_id = ac_payroll_item.id AND ansena_attend.attend != 'OUT' AND DATE_FORMAT(ansena_attend.time_scan, '%Y-%m-%d') = event_date
                                WHERE is_active = 1
                                AND barcode IS NOT NULL
                                AND events_attend.time_scan IS NULL
                                AND office = " . $dept_id . "
                                GROUP BY ac_payroll_item.id
                                ORDER BY ac_payroll_item.name ASC";

            $department = $this->db->query("SELECT CONCAT('d', id) AS 'id', name 
                                                    FROM ansena_department
                                                    WHERE id = " . $dept_id)->result();

        } elseif (substr($department, 0, 1) == 't') {

            $dept_id = preg_replace('/[^0-9]/', '', $department);

			$query = "SELECT ac_payroll_item.id,
							ac_payroll_item.name AS employee_name, 
							is_pt,
                            gender,
							IF(is_pt = 1, CONCAT('PT. ', REPLACE(ansena_department.name, 'PT. ', '')), REPLACE(ansena_department.name, 'PT. ', '')) AS 'department',
							ansena_division.division, 
							ansena_team.team,
                            event_date,
                            event_time,
							IF(time_scan IS NOT NULL, MIN(time_scan), NULL) AS 'time_in',
							IF(time_scan IS NOT NULL, MAX(time_scan), NULL) AS 'time_out',
							IF(time_scan IS NOT NULL, TIMEDIFF(MAX(time_scan), MIN(time_scan)), NULL) AS 'time_diff',
							MAX(IF(events_attend.attend = 'IN', review_events, 0)) AS 'review_in',
							MAX(IF(events_attend.attend = 'OUT', review_events, 0)) AS 'review_out'
							FROM ac_payroll_item
							LEFT JOIN events_attend ON events_attend.ac_payroll_item_id = ac_payroll_item.id AND event_id = " . $this->input->post('event_id') . "
                            LEFT JOIN events ON events.id = events_attend.event_id
							JOIN ansena_department ON ansena_department.id = ac_payroll_item.office
							JOIN ansena_division ON ansena_division.id = ac_payroll_item.division
							LEFT JOIN ansena_team_detail ON ansena_team_detail.ac_payroll_item_id = ac_payroll_item.id
							LEFT JOIN ansena_team ON ansena_team.id = ansena_team_detail.ansena_team_id
							WHERE is_active = 1
                            AND barcode IS NOT NULL
                            AND time_scan IS NOT NULL
							AND ansena_team.id = " . $dept_id . "
							GROUP BY ac_payroll_item.id
                            ORDER BY ac_payroll_item.name ASC";
                            
            $query_2 = "SELECT ac_payroll_item.id,
                                ac_payroll_item.name AS employee_name, 
                                is_pt,
                                gender,
                                IF(is_pt = 1, CONCAT('PT. ', REPLACE(ansena_department.name, 'PT. ', '')), REPLACE(ansena_department.name, 'PT. ', '')) AS 'department',
                                ansena_division.division, 
                                ansena_team.team,
                                event_date,
                                event_time,
                                IF(events_attend.time_scan IS NOT NULL, MIN(events_attend.time_scan), NULL) AS 'time_in',
                                IF(events_attend.time_scan IS NOT NULL, MAX(events_attend.time_scan), NULL) AS 'time_out',
                                IF(events_attend.time_scan IS NOT NULL, TIMEDIFF(MAX(events_attend.time_scan), MIN(events_attend.time_scan)), NULL) AS 'time_diff',
                                MAX(IF(events_attend.attend = 'IN', review_events, 0)) AS 'review_in',
                                MAX(IF(events_attend.attend = 'OUT', review_events, 0)) AS 'review_out',
                                ansena_attend.attend
                                FROM ac_payroll_item
                                LEFT JOIN events_attend ON events_attend.ac_payroll_item_id = ac_payroll_item.id AND event_id = " . $this->input->post('event_id') . "
                                RIGHT JOIN events ON events.id = " . $this->input->post('event_id') . "
                                JOIN ansena_department ON ansena_department.id = ac_payroll_item.office
                                JOIN ansena_division ON ansena_division.id = ac_payroll_item.division
                                LEFT JOIN ansena_team_detail ON ansena_team_detail.ac_payroll_item_id = ac_payroll_item.id
                                LEFT JOIN ansena_team ON ansena_team.id = ansena_team_detail.ansena_team_id
                                LEFT JOIN ansena_attend ON ansena_attend.ac_payroll_item_id = ac_payroll_item.id AND ansena_attend.attend != 'OUT' AND DATE_FORMAT(ansena_attend.time_scan, '%Y-%m-%d') = event_date
                                WHERE is_active = 1
                                AND barcode IS NOT NULL
                                AND events_attend.time_scan IS NULL
                                AND ansena_team.id = " . $dept_id . "
                                GROUP BY ac_payroll_item.id
                                ORDER BY ac_payroll_item.name ASC";

            $department = $this->db->query("SELECT CONCAT('t', id) AS 'id', team AS 'name'
                                                 FROM ansena_team
                                                 WHERE id = " . $dept_id)->result();

        }

        $event = $this->db->query("SELECT detail, participant, report 
                                        FROM events WHERE id = " . $this->input->post('event_id'))->row_array();

        $attr = array(
                        'attend_null' => $this->db->query($query_2)->result(),
                        'attend'    => $this->db->query($query)->result(),
                        'event_id'  => $this->input->post('event_id'),
                        'event'     => $event,
                        'department' => $department
        );

        $this->load->view('attend/attend-event/report-attend-event', $attr);

    }
    // End of function load_data

}