<?php
defined('BASEPATH') OR exit('No direct script access allowed');
date_default_timezone_set('Asia/Jakarta');

/*
 * Class Attend_settings
 */
class Attend_settings extends CI_Controller {

	function __construct() {
		parent::__construct();

		if (! $this->session->userdata('ac_payroll_item_id')) {
			$this->session->set_flashdata('alert-error', 'Sesi telah berakhir');
			redirect('login');
		}
	}
	// End of function construct

    public function shift() {

		$sintax = $this->restrict_lib->query_access();

		$attr = array(
						'department' => $this->db->query($sintax)->result()
		);

		$this->load->view('attend/layouts/header');
		$this->load->view('attend/layouts/navbar');
		$this->load->view('attend/settings/shift/navbar-sub');
		$this->load->view('attend/layouts/content-wrapper');
		$this->load->view('attend/settings/shift/index', $attr);
		$this->load->view('attend/layouts/footer');
    }
    // End of function shift

	public function working_time() {

		$this->load->view('attend/layouts/header');
		$this->load->view('attend/layouts/navbar');
		$this->load->view('attend/settings/working-time/navbar-sub');
		$this->load->view('attend/layouts/content-wrapper');
		$this->load->view('attend/settings/working-time/index');
		$this->load->view('attend/layouts/footer');
	}
	// End of function working_time

	/***************************************************** API *****************************************************/
	
	public function load_working_time() {

		$query = "SELECT CONCAT(IF(is_pt = 1, CONCAT('PT. ', REPLACE(name, 'PT. ', '')), REPLACE(name, 'PT. ', '')), ' (', team, ')') AS 'name',
						CONCAT('t', ansena_team.id) AS 'id',
						ansena_team.attend
						FROM ansena_team 
						LEFT JOIN ansena_department ON ansena_department.id = ansena_team.dept_id 
						AND progress != 0
						UNION ALL 
						SELECT IF(is_pt = 1, CONCAT('PT. ', REPLACE(name, 'PT. ', '')), REPLACE(name, 'PT. ', '')) AS 'name',
						CONCAT('d', ansena_department.id) AS 'id',
						ansena_department.attend
						FROM ansena_department 
						LEFT OUTER JOIN ansena_team ON ansena_team.dept_id = ansena_department.id 
						WHERE ansena_team.id IS NULL
						AND progress != 0";

		$department = $this->db->query($query)->result();

		echo json_encode($department);
	}
	// End of function load_working_time

    /**
     * @param post => dept_id
     */
    public function load_employee_list() {

        $department = $this->input->post('dept_id');

        if (substr($department, 0, 1) == 'd') {

			$department = preg_replace("/[^0-9]/", "", $department);

			$query = $this->db->query("SELECT ac_payroll_item.id, name, shift, ansena_division.division
											FROM ac_payroll_item
                                            JOIN ansena_division ON ansena_division.id = ac_payroll_item.division
											WHERE is_active = 1
											AND office = '" . $department . "'
											ORDER BY name ASC");
		
		} else {

			$department = preg_replace("/[^0-9]/", "", $department);

			$query = $this->db->query("SELECT ac_payroll_item.id, name, shift, ansena_division.division
											  FROM ac_payroll_item
											  JOIN ansena_team_detail ON ansena_team_detail.ac_payroll_item_id = ac_payroll_item.id
                                              JOIN ansena_division ON ansena_division.id = ac_payroll_item.division
											  WHERE is_active = 1
											  AND ansena_team_id = " . $department . "
											  ORDER BY name ASC");
		}

        $count = $query->num_rows();
        $result = $query->result();

        $attr = array(
                        'count' => $count,
                        'employee' => $result
        );

		$this->load->view('attend/settings/shift/employee-list', $attr);
    }
    // End of function load_employee_list  

    /**
     * @param post => ac_payroll_item_id
     * @param post => shift
     */
    public function update_shift() {

        $ac_payroll_item_id = $this->input->post('ac_payroll_item_id');
        $shift = $this->input->post('shift');
		
		$query = $this->db->query("SELECT shift
										FROM ac_payroll_item
										WHERE id = " . $ac_payroll_item_id)->row_array();

		$shift_before = $query['shift'];

        $data = array(
                        'shift' => $shift
        );

        $this->db->where('id', $ac_payroll_item_id);
        $this->db->update('ac_payroll_item', $data);

		// param, object, param_before, param_after
		$this->log_lib->log(1, $ac_payroll_item_id, $shift_before, $shift);
    }
    // End of function update_shift

	public function change_password_user() {

		$this->load->view('attend/layouts/header');
		$this->load->view('attend/layouts/navbar');
		$this->load->view('attend/settings/password/navbar-sub');
		$this->load->view('attend/layouts/content-wrapper');
		$this->load->view('attend/settings/password/change-password-user');
		$this->load->view('attend/layouts/footer');
	}
	// End of function change_password_user

	public function save_new_password() {

		$password = $this->input->post('user_password');
		$ac_payroll_item_id = $this->session->userdata('ac_payroll_item_id');

		$encrypt_password = $this->encryption->encrypt($password);

		$data = array(
						'password' => $encrypt_password
		);

		$this->db->where('id', $ac_payroll_item_id);
		$this->db->update('ac_payroll_item', $data);
	}
	// End of function save_new_password

	/**
	 * @param post => id
	 * @param post => working_time
	 */
	public function save_working_time() {

		$this->db->trans_start();

		$id = $this->input->post('id');
		$working_time = $this->input->post('working_time');

		for ($i = 0; $i < count($id); $i++) {

			if ($working_time[$i] == 'null' || $working_time[$i] == '') {
				$attend = null;
			} else {
				$attend = $working_time[$i];
			}

			$key = substr($id[$i], 0, 1);

			if ($key == 'd') {

				$department = preg_replace("/[^0-9]/", "", $id[$i]);

				$data = array(
								'attend' => $attend
				);

				$this->db->where('id', $department);
				$this->db->update('ansena_department', $data);
			} else {

				$department = preg_replace("/[^0-9]/", "", $id[$i]);

				$data = array(
								'attend' => $attend
				);

				$this->db->where('id', $department);
				$this->db->update('ansena_team', $data);
			}
		}

		$this->db->trans_complete();

		if ($this->db->trans_status() === FALSE) {
    		echo json_encode('error');
		} else {
			echo json_encode('success');
		}
	}
	// End of function save_working_time

}
/* End of file Attend_settings.php */
/* Location: ./application/controllers/Attend_settings.php */

