<?php
defined('BASEPATH') OR exit('No direct script access allowed');
date_default_timezone_set('Asia/Jakarta');

/*
 * Class Ansena_team
 */
class Ansena_team extends CI_Controller {

	function __construct() {
		parent::__construct();

		if (! $this->session->userdata('ac_payroll_item_id')) {
			$this->session->set_flashdata('alert-error', 'Sesi telah berakhir');
			redirect('login');
		}
	}
	
	public function form_edit_ansena_team() {

		$id = $this->input->get('ansena_team_id');

		$attr = array(
						'team_id'		=> $id,
						'department' 	=> $this->db->query("SELECT id,
																 	IF(is_pt = 1, CONCAT('PT. ', REPLACE(name, 'PT. ', '')), REPLACE(name, 'PT. ', '')) AS 'name' 
																 	FROM ansena_department
																 	ORDER BY sort ASC")->result(),
						'team'			=> $this->db->query("SELECT ansena_team.id,
																	dept_id,
																	team,
																	IF(is_pt = 1, CONCAT('PT. ', REPLACE(name, 'PT. ', '')), REPLACE(name, 'PT. ', '')) AS 'department_name' 
																	FROM ansena_team
																	JOIN ansena_department ON ansena_department.id = ansena_team.dept_id
																	WHERE ansena_team.id = " . $id)->row_array()
					);

		$this->load->view('attend/ansena-team/form-edit-ansena-team', $attr);
	}
	// End of function form_edit_ansena_team

	public function index() {

		$attr = array(
						'department' 	=> $this->db->query("SELECT id,
																 	IF(is_pt = 1, CONCAT('PT. ', REPLACE(name, 'PT. ', '')), REPLACE(name, 'PT. ', '')) AS 'name' 
																 	FROM ansena_department
																 	ORDER BY sort ASC")->result()
					);

		$this->load->view('attend/layouts/header');
		$this->load->view('attend/layouts/navbar');
		$this->load->view('attend/ansena-team/navbar-sub');
		$this->load->view('attend/layouts/content-wrapper');
		$this->load->view('attend/ansena-team/index', $attr);
		$this->load->view('attend/layouts/footer');
	}
	// End of function index

	public function form_select_ansena_team() {

		$dept_id = $this->input->get('dept_id');

		$ansena_team = $this->db->query("SELECT id,
												team
												FROM ansena_team
												WHERE dept_id = " . $dept_id . "
												ORDER BY team ASC")->result();

		$html = '<select class="form-control" id="x" class="select-ansena-team" onchange="select_ansena_team(this)">';
		$html .= '<option value="" selected disabled>Pilih Team</option>';
		foreach ($ansena_team as $row) :
			$html .= '<option value="' . $row->id . '" data-target="' . $row->team . '">' . $row->team . '</option>';
		endforeach;
		$html .= '</select>';

		$attr = array(
						'ac_payroll_item' 	=> $this->db->query("SELECT ac_payroll_item.id,
																  		ac_payroll_item.name,
																  		team
																  		FROM ac_payroll_item
																  		LEFT JOIN ansena_team_detail ON ansena_team_detail.ac_payroll_item_id = ac_payroll_item.id
																  		LEFT JOIN ansena_team ON ansena_team.id = ansena_team_detail.ansena_team_id
																  		WHERE office = " . $dept_id . "
																		  AND is_active = 1
																		  AND barcode IS NOT NULL
																  		ORDER BY name ASC")->result(),
						'select_ansena_team'=> $html
					);

		$this->load->view('attend/ansena-team/form-select-ansena-team', $attr);
		
	}
	// End of function form_select_ansena_team


	##################################################################################################################################
	#                                                              API                                                               #
	##################################################################################################################################

	/**
	 * @param $columnOrder
	 * @param $columnSearch
	 * @param $order
	 */
	public function server_side_data() {

		// Set field order column
		$columnOrder = array('dept_id', 'team', '');

		// Set field search column
	    $columnSearch = array(
    						array(
    							'format' 	=> 'string',
    							'field' 	=> 'dept_id',
    							'type' 		=> 'select-multiple'
    						),
    						array(
    							'format' 	=> 'string',
    							'field' 	=> 'team',
    							'type' 		=> 'search'
    						)
	    				);
    	
    	// Set field ordering
    	$order = array('team' => 'asc');

    	// Query
    	$query = "SELECT ansena_team.id,
    					 team,
    					 IF(is_pt = 1, CONCAT('PT. ', REPLACE(name, 'PT. ', '')), REPLACE(name, 'PT. ', '')) AS 'department_name'
    					 FROM ansena_team
    					 JOIN ansena_department ON ansena_department.id = ansena_team.dept_id ";

   		$query .= $this->server_side_lib->individual_column_filtering_default($columnSearch);

   		$query .= $this->server_side_lib->ordering($columnOrder, $order);

   		$ansena_team = $query . $this->server_side_lib->limit();

   		$results = $this->db->query($ansena_team)->result();

   		// Loop
		$data = array();

		foreach ($results as $rows) :

			$row = array();

			$row[] = $rows->department_name;

			$row[] = $rows->team;

			$btnEdit = '<a href="javascript:void(0)" onclick="edit_ansena_team(' . $rows->id . ')" class="btn btn-sm btn-outline-warning"><i class="fa fa-edit"></i></a>';

			$btnDelete = '<a href="javascript:void(0)" id="btn-confirm-delete" key="' . $rows->id . '" class="btn btn-sm btn-outline-danger"><i class="fa fa-trash"></i></a>';

			$row[] = '<div class="btn-group">' . $btnEdit . $btnDelete . '</div>';

			$data[] = $row;

		endforeach;

		$output = array(
						"draw" 				=> $_POST['draw'],
            			"recordsTotal" 		=> $this->db->from('ansena_team')->count_all_results(),
            			"recordsFiltered" 	=> $this->db->query($query)->num_rows(),
						"data" 				=> $data
					);

		echo json_encode($output);
		
	}
	// End of function server_side_data
	
	/**
	 * @return json
	 */
	public function load_team_list() {
		
		if (empty($this->input->get('team'))) {

			$data['result'] = $this->db->query("SELECT id,
													   team
													   FROM ansena_team
													   ORDER BY team ASC")->result();

		} else {

			$data['result'] = $this->db->query("SELECT id,
													   team
													   FROM ansena_team
													   WHERE team LIKE '%" . $this->input->get('team') . "%'
													   ORDER BY team ASC")->result();

		}

		echo json_encode($data);

	}	
	// End of function load_team_list

	/**
	 * @param post => dept_id
	 * @param post => team
	 */
	public function save_new_ansena_team() {

		if (empty($this->input->post('dept_id')) || empty($this->input->post('team_name'))) {

			echo 'error-null';

		} else {

			$this->db->where('team', ucwords($this->input->post('team_name')));
			$ansena_team = $this->db->get('ansena_team')->row();

			if (! empty($ansena_team)) {

				echo 'error-duplicate-team';

			} else {

				$data = array(
								'dept_id'		=> $this->input->post('dept_id'),
								'team'			=> ucwords($this->input->post('team_name')),
								'created_time'	=> date('Y-m-d H:i:s'),
								'updated_time'	=> date('Y-m-d H:i:s'),
								'creator'		=> $this->session->userdata('ac_payroll_item_id')
							);

				$this->db->insert('ansena_team', $data);

				echo 'success';

			}

		}
		
	}
	// End of function save_new_ansena_team

	/**
	 * @param post => dept_id
	 * @param post => team
	 */
	public function update_team($id) {

		if (empty($this->input->post('dept_id')) || empty($this->input->post('team_name'))) {

			echo 'error-null';

		} else {

			$ansena_team = $this->db->query("SELECT id
													FROM ansena_team
													WHERE team = '" . ucwords($this->input->post('team_name')) . "'
													AND id != " . $id);

			$checkDuplicate = $ansena_team->num_rows();

			if ($checkDuplicate > 0) {

				echo 'error-duplicate-team';

			} else {

				$data = array(
								'dept_id'		=> $this->input->post('dept_id'),
								'team'			=> ucwords($this->input->post('team_name')),
								'updated_time'	=> date('Y-m-d H:i:s'),
								'creator'		=> $this->session->userdata('ac_payroll_item_id')
							);

				$this->db->where('id', $id);
				$this->db->update('ansena_team', $data);

				echo 'success';

			}

		}
		
	}
	// End of function update_team

	/**
	 * @param post => id
	 * @return bool
	 */
	public function delete_team() {

		$this->db->trans_start();

		$this->db->where('id', $this->input->post('id'));
		$this->db->delete('ansena_team');

		// is successful trans
		if ($this->db->trans_status() === false) {

			$this->db->trans_rollback();

			echo 'error';

		} else {

			$this->db->trans_commit();

			echo 'success';

		}
		
	}
	// End of function delete_team

	/**
	 * @param post => ac_payroll_item_id
	 * @param post => ansena_team_id
	 */
	public function insert_ansena_team() {

		$ac_payroll_item_id = $this->input->post('ac_payroll_item_id');
		$ansena_team_id = $this->input->post('value');
		
		$countDetail = $this->db->query("SELECT id
												FROM ansena_team_detail
												WHERE ac_payroll_item_id = " . $ac_payroll_item_id)->num_rows();

		if ($countDetail > 0) {

			$data = array(
							'ansena_team_id' 		=> $ansena_team_id,
							'updated_time'			=> date('Y-m-d H:i:s'),
							'creator'				=> $this->session->userdata('ac_payroll_item_id')
						);

			$this->db->where('ac_payroll_item_id', $ac_payroll_item_id);
			$this->db->update('ansena_team_detail',  $data);

		} else {

			$data = array(
							'ansena_team_id'		=> $ansena_team_id,
							'ac_payroll_item_id'	=> $ac_payroll_item_id,
							'created_time'			=> date('Y-m-d H:i:s'),
							'updated_time'			=> date('Y-m-d H:i:s'),
							'creator'				=> $this->session->userdata('ac_payroll_item_id')
						);

			$this->db->insert('ansena_team_detail', $data);

		}

		echo 'success';

	}
	// End of function insert_ansena_team

}

/* End of file Ansena_team.php */
/* Location: ./application/controllers/Ansena_team.php */
