<?php
defined('BASEPATH') OR exit('No direct script access allowed');
date_default_timezone_set('Asia/Jakarta');

/*
 * Class Feeling_today
 */
class Feeling_today extends CI_Controller {

	function __construct() {
		parent::__construct();

		if (! $this->session->userdata('ac_payroll_item_id')) {
			$this->session->set_flashdata('alert-error', 'Sesi telah berakhir');
			redirect('login');
		}
	}
	// End of function construct

    public function index() {

		if (! $this->session->userdata('ac_payroll_item_id')) {
			$this->session->set_flashdata('alert-error', 'Sesi telah berakhir');
			redirect('login');
		}
		
		$sintax = $this->restrict_lib->query_access();

		$attr = array(
						'department' => $this->db->query($sintax)->result()
		);

		$this->load->view('attend/layouts/header');
		$this->load->view('attend/layouts/navbar');
		$this->load->view('attend/feeling-today/navbar-sub');
		$this->load->view('attend/layouts/content-wrapper');
		$this->load->view('attend/feeling-today/feeling-today', $attr);
		$this->load->view('attend/layouts/footer');

	}
	// End of function index

	public function list() {

		if (! $this->session->userdata('ac_payroll_item_id')) {
			$this->session->set_flashdata('alert-error', 'Sesi telah berakhir');
			redirect('login');
		}

		$department_id = $this->input->get('department');
		$month = $this->input->get('month');

        $query = $this->db->query("SELECT attend_date, detail
										  FROM ansena_attend_resume
										  WHERE DATE_FORMAT(attend_date, '%Y-%m') = '" . $month . "'
										  ORDER BY attend_date ASC")->result_array();

		if (substr($department_id, 0, 1) == 'd') {

			$dept_id = preg_replace('/[^0-9]/', '', $department_id);

			$masterData = $this->db->query("SELECT id, name, division
												FROM ac_payroll_item
												WHERE is_active = 1
												AND office = '" . $dept_id. "'
												AND DATE_FORMAT(date_join, '%Y-%m') <= '" . $month . "'
												AND barcode IS NOT NULL
												AND ac_payroll_item.id != 1
												ORDER BY name ASC")->result();

			$department = $this->db->query("SELECT IF(is_pt = 1, CONCAT('PT. ', REPLACE(ansena_department.name, 'PT. ', '')), REPLACE(ansena_department.name, 'PT. ', '')) AS 'name' FROM ansena_department WHERE id = " . $dept_id)->row_array();

		} else {

			$dept_id = preg_replace('/[^0-9]/', '', $department_id);

			$masterData = $this->db->query("SELECT ac_payroll_item.id, name, division
												FROM ac_payroll_item
												JOIN ansena_team_detail ON ansena_team_detail.ac_payroll_item_id = ac_payroll_item.id
												WHERE is_active = 1
												AND ansena_team_detail.ansena_team_id = '" . $dept_id . "'
												AND DATE_FORMAT(date_join, '%Y-%m') <= '" . $month . "'
												AND barcode IS NOT NULL
												AND ac_payroll_item.id != 1
												ORDER BY name ASC")->result();

			$department = $this->db->query("SELECT CONCAT(IF(is_pt = 1, CONCAT('PT. ', REPLACE(ansena_department.name, 'PT. ', '')), REPLACE(ansena_department.name, 'PT. ', '')), ' (', team, ')') AS 'name'
												   FROM ansena_team
												   JOIN ansena_department ON ansena_department.id = ansena_team.dept_id 
												   WHERE ansena_team.id = " . $dept_id)->row_array();

		}

		$attr = array(
						'department' => $department['name'],
						'period' => date('M Y', strtotime($month)),
						'attendData' => $query,
						'masterData' => $masterData
					);

		if (count($query) == 0 || count($masterData) == 0) {
			echo 'error-null';
		} else {
			$this->load->view('attend/feeling-today/monthly-feeling-result', $attr);
		}

	}
	// End of function list

}
/* End of file Feeling_today.php */
/* Location: ./application/controllers/Feeling_today.php */