<?php
defined('BASEPATH') OR exit('No direct script access allowed');
date_default_timezone_set('Asia/Jakarta');

/*
 * Class Login
 */
class Login extends CI_Controller {

	/**
	 * Access allowed for
	 * 24 => CHO
	 * 63 => HRD Super
	 *  3 => HC
	 *  5 => HRD
	 * 60 => HRD Senior
	 * 58 => Programmer 2
	 * 28 => CWO
	 * 54 => Manager Audit
	 * 
	 * Condition 
	 *  1 => All Access
	 *  2 => Per seri
 	 *  3 => Per dept
	 */

	var $accessAllowed = array(
								'k24' => 1, 
								'k63' => 1, 
								'k3' => 2, 
								'k5' => 3, 
								'k60' => 3,
								'k58' => 1, 
								'k28' => 1,
								'k54' => 2,
								'k81' => 3
						);

	function __construct() {

		parent::__construct();

		// is session ac_payroll_item_id
		if ($this->session->userdata('ac_payroll_item_id')) {
			redirect('dashboard');
		}
	}
	// End of function __construct

	public function index() {

		// is submit post
		if ($this->input->post('btn-login')) {

            $username = $this->input->post('username');
            $password = $this->input->post('password');

			// is empty post
			if (empty($username) || empty($password)) {

				$this->session->set_flashdata('alert-error', 'Username & password harus diisi');
				$this->session->set_flashdata('animation-error', 'shake-horizontal');

				redirect('login/index');

			} else {

                $query = $this->db->query("SELECT ac_payroll_item.id, ac_payroll_item.password, division, office, seri
                                                FROM ac_payroll_item
												JOIN ansena_department ON ansena_department.id = ac_payroll_item.office
                                                WHERE username = '" . $username . "'");

				// is empty user
				if ($query->num_rows() > 0) {

                    $result = $query->row_array();

					// Access allowed
					if (isset($this->accessAllowed['k' . $result['division']])) {
						
						// Auth
						if ($this->encryption->decrypt($result['password']) == $password) {

							// Set Session
							$data = array(
											'ac_payroll_item_id' 	=> $result['id'],
											'username' 				=> $username,
											'access_allowed' 		=> $this->accessAllowed['k' . $result['division']],
											'department'			=> $result['office'],
											'seri'					=> $result['seri'],
											'division'				=> $result['division']
							);

							$this->session->set_userdata($data);
							$this->session->set_flashdata('alert-success', 'Login berhasil');

							// Redirect
							redirect('attend/index');
						} else {

							$this->session->set_flashdata('alert-error', 'Password salah');
							$this->session->set_flashdata('animation-error', 'shake-horizontal');

							redirect('login/index');
						}
						// End of file auth
					} else {
						
						$this->session->set_flashdata('alert-error', 'Akses dibatasi');
						redirect('login/index');
					}

				} else {

					$this->session->set_flashdata('alert-error', 'Username tidak terdaftar');
					$this->session->set_flashdata('animation-error', 'shake-horizontal');

					redirect('login/index');

				}	
				// End of if user not found

			}
			// End of if empty username || password

		}
		// End of if post btn-login

		if ($this->input->get('destroy') == 1) {

			$this->session->set_flashdata('alert-success', 'Logout berhasil');
			redirect('login/index');

		}

		$this->session->set_flashdata('animation', 'slide-top');

		$this->load->view('login/index');
		
	}
	// End of function index

}
/* End of file Login.php */
/* Location: ./application/controllers/Login.php */