
    <!-- DataTables FixedColumn v3.1.1 with Bootstrap v4.4.11 -->
    <link rel="stylesheet" href="<?=base_url();?>assets/vendor/datatables/fixedcolumn/css/fixedColumns.dataTables.min.css?v3.1.1">
    <link rel="stylesheet" href="<?=base_url();?>assets/vendor/datatables/fixedcolumn/css/fixedColumns.bootstrap4.min.css?v3.1.1">

    <!-- DataTables FixedColumn v3.1.1 with Bootstrap v4.4.11 -->
    <script src="<?=base_url();?>assets/vendor/datatables/fixedcolumn/js/dataTables.fixedColumns.min.js?v3.1.1"></script>
    <script src="<?=base_url();?>assets/vendor/datatables/fixedcolumn/js/fixedColumns.bootstrap4.min.js?v3.1.1"></script>

    <style>
        .btn-period.active {
            background-color: var(--primary);
            color: white;
        }
        #monthly, #daily {
            padding-top: 1rem;
        }
    </style>

	<div class="row">

		<div class="col-md-12">

			<div class="card">
				<div class="card-body">
                    
                    <div class="row">
                        <div class="col-12">
                            <button id="period-0" class="btn btn-default btn-period" onclick="select_period(0)">Daily</button> <button id="period-1" class="btn btn-default btn-period" onclick="select_period(1)">Monthly</button>
                        </div>
                    </div>
                    
                    <div class="row" id="daily" style="display: none">
                        <div class="col-12">
                            <div class="form-inline float-sm-left">
                                <div class="input-group" style="padding-right:.5rem">
                                    <select class="form-control select2" name="department" id="department-daily">
                                        <option selected disabled>Pilih Department</option>
                                        <?php
                                        foreach ($department as $row):
                                            echo '<option value="' . $row->id . '">' . $row->name . '</option>';
                                        endforeach;
                                        ?>
                                    </select>
                                </div>
                                <div class="input-group" style="padding-right:.5rem">
                                    <input type="text" class="form-control single-datepicker" name="date_input" id="date_input" placeholder="Pilih tanggal" readonly>
                                </div>
                                <button type="button" class="btn btn-primary" id="btn-submit-daily">Submit</button>
                            </div>
                        </div>
                    </div>

                    <div class="row" id="monthly" style="display: none">
                        <div class="col-12">
                            <div class="form-inline float-sm-left">
                                <div class="input-group" style="padding-right:.5rem">
                                    <select class="form-control select2" name="department" id="department-monthly">
                                        <option selected disabled>Pilih Department</option>
                                        <?php
                                        foreach ($department as $row):
                                            echo '<option value="' . $row->id . '">' . $row->name . '</option>';
                                        endforeach;
                                        ?>
                                    </select>
                                </div>
                                <div class="input-group" style="padding-right:.5rem">
                                    <input type="text" class="form-control monthly-datepicker" name="month" id="month" placeholder="Pilih periode" readonly>
                                </div>
                                <button type="button" class="btn btn-primary" id="btn-submit-monthly">Submit</button>
                            </div>
                        </div>
                    </div>

				</div>
			</div>

		</div>

	</div>

    <div class="row">

		<div class="col-12">

			<div id="feeling-today"></div>

		</div>
		<!-- /div.col -->

    </div>
    <!-- /div.row -->

    <script>

        $(document).ready( function() {

             $('#btn-submit-daily').click( function () {

                var department = $('#department-daily');
                var date_input = $('#date_input');

                if (department.val() == '' || department.val() == null) {
                    Swal.fire({
                        position: 'center',
                        icon: 'warning',
                        title: 'Pilih department',
                        showConfirmButton: false,
                        timer: 1000
                    });

                    department.focus();

                    return false;

                }

                if (date_input.val() == '') {
                    Swal.fire({
                        position: 'center',
                        icon: 'warning',
                        title: 'Pilih tanggal',
                        showConfirmButton: false,
                        timer: 1000
                    });

                    date_input.focus();

                    return false;

                }

                $.ajax({
                    url: "<?=site_url('attend/feeling_today_list');?>",
                    type: "get",
                    data: {
                        department : department.val(),
                        date_input : date_input.val()
                    },
                    cache: false,
                    beforeSend: function() {
                        var loading = '<div class="overlay text-center"><i class="fas fa-3x fa-sync-alt fa-spin"></i><div class="text-bold pt-2">Loading...</div></div>';
                        $('#feeling-today').html(loading);
                    },
                    success: function(response) {

                        if (response == 'error-null') {
                            Swal.fire({
                                position: 'center',
                                icon: 'warning',
                                title: 'Data tidak ditemukan',
                                showConfirmButton: false,
                                timer: 1000
                            });

                            $('#feeling-today').html('');
                        } else {
                            $('#feeling-today').html(response);
                        }
                    }

                });

            });


            $('#btn-submit-monthly').click( function () {

                var department = $('#department-monthly');
                var month = $('#month');

                if (department.val() == '' || department.val() == null) {
                    Swal.fire({
                        position: 'center',
                        icon: 'warning',
                        title: 'Pilih department',
                        showConfirmButton: false,
                        timer: 1000
                    });

                    department.focus();

                    return false;

                }

                if (month.val() == '') {
                    Swal.fire({
                        position: 'center',
                        icon: 'warning',
                        title: 'Pilih periode',
                        showConfirmButton: false,
                        timer: 1000
                    });

                    month.focus();

                    return false;

                }

                $.ajax({
                    url: "<?=site_url('feeling_today/list');?>",
                    type: "get",
                    data: {
                        department : department.val(),
                        month : month.val()
                    },
                    cache: false,
                    beforeSend: function() {
                        var loading = '<div class="overlay text-center"><i class="fas fa-3x fa-sync-alt fa-spin"></i><div class="text-bold pt-2">Loading...</div></div>';
                        $('#feeling-today').html(loading);
                    },
                    success: function(response) {

                        if (response == 'error-null') {
                            Swal.fire({
                                position: 'center',
                                icon: 'warning',
                                title: 'Data tidak ditemukan',
                                showConfirmButton: false,
                                timer: 1000
                            });

                            $('#feeling-today').html('');
                        } else {
                            $('#feeling-today').html(response);
                        }
                    }

                });

            });

        });

        function select_period(param) {

            $('.btn-period').removeClass('active');
            $('#period-' + param).addClass('active');

            $('#feeling-today').html('');

            if (param == 0) {
                $('#monthly').hide();
                $('#daily').show();
            } else {
                $('#daily').hide();
                $('#monthly').show();
            }
        } 

    </script>