
    <div class="row">

        <div class="col-2">

            <div class="card card-body">
                <input type="date" class="form-control" id="date-selected" onchange="load_data()">
            </div>
            <!--/.card -->

        </div>
        <!--/.col -->

    </div>
    <!--/.row -->

    <div class="row">

        <div class="col-12">

            <div class="card card-body">

                <div id="loading-data">
                    No avaiable data
                </div>

                <table id="table-attend"></table>

            </div>

        </div>

    </div>

    <script>

        function load_data() {

            var date_selected = $('#date-selected').val();

            if (date_selected != '') {

                $.ajax({
                    url: "<?=site_url('attend_settings/load_attend');?>",
                    type: "post",
                    data: {
                        date: date_selected
                    },
                    dataType: "json",
                    beforeSend: function () {
                        var loading = '<div class="overlay dark"><div class="spinner-border ms-auto" role="status" aria-hidden="true"></div></div>';
                        $('#loading-data').html(loading);
                    },
                    success: function (data) {

                        $('#loading-data').html('');

                        $('#table-attend').html('');
                        
                        if (data.length > 0) {

                            append_header();

                            for (i = 0; i < data.length; i++) {
                                append_row(data[i], i);
                            }

                        } else {

                            $('#loading-data').html('No avaiable data');
                        }
                    }
                });
            }
        }

        function append_header() {

            var tableAttend = document.getElementById('table-attend');

            var l = tableAttend.rows.length;
            var row = tableAttend.insertRow(l);

            var cell1 = row.insertCell(0);
            var cell2 = row.insertCell(1);
            var cell3 = row.insertCell(2);
            var cell4 = row.insertCell(3);
            var cell5 = row.insertCell(4);
            var cell6 = row.insertCell(5);
            var cell7 = row.insertCell(6);
            var cell8 = row.insertCell(7);

            cell1.innerHTML = 'id';
            cell2.innerHTML = 'ac_payroll_item_id';
            cell3.innerHTML = 'shift';
            cell4.innerHTML = 'time_scan';
            cell5.innerHTML = 'attend';
            cell6.innerHTML = 'attend_status';
            cell7.innerHTML = 'hrd_act';
            cell8.innerHTML = 'mood';

        }

        function append_row(data, i) {

            var tableAttend = document.getElementById('table-attend');

            var l = tableAttend.rows.length;
            var row = tableAttend.insertRow(l);

            var cell1 = row.insertCell(0);
            var cell2 = row.insertCell(1);
            var cell3 = row.insertCell(2);
            var cell4 = row.insertCell(3);
            var cell5 = row.insertCell(4);
            var cell6 = row.insertCell(5);
            var cell7 = row.insertCell(6);
            var cell8 = row.insertCell(7);
            var cell9 = row.insertCell(8);

            cell1.innerHTML = '<input type="text" class="form-control form-control-sm" value="' + data.id + '">';
            cell2.innerHTML = '<input type="text" class="form-control form-control-sm" value="' + data.ac_payroll_item_id + '" id="ac-payroll-item-id-' + data.id + '" onchange="update_data(' + data.id + ')">';
            cell3.innerHTML = '<input type="text" class="form-control form-control-sm" value="' + data.shift + '" id="shift-' + data.id + '" onchange="update_data(' + data.id + ')">';
            cell4.innerHTML = '<input type="text" class="form-control form-control-sm" value="' + data.time_scan + '" id="time-' + data.id + '" onchange="update_data(' + data.id + ')">';
            cell5.innerHTML = '<input type="text" class="form-control form-control-sm" value="' + data.attend + '" id="attend-' + data.id + '" onchange="update_data(' + data.id + ')">';
            cell6.innerHTML = '<input type="text" class="form-control form-control-sm" value="' + data.attend_status + '" id="attend-status-' + data.id + '" onchange="update_data(' + data.id + ')">';
            cell7.innerHTML = '<input type="text" class="form-control form-control-sm" value="' + data.hrd_act + '" id="hrd-act-' + data.id + '" onchange="update_data(' + data.id + ')">';
            cell8.innerHTML = '<input type="text" class="form-control form-control-sm" value="' + data.mood + '" id="mood-' + data.id + '" onchange="update_data(' + data.id + ')">';
            cell9.innerHTML = '<button class="btn btn-xs btn-danger" id="btn-' + data.id + '" onclick="delete_data(' + data.id + ')">x</button>';
        }

        function delete_data(id) {

            Swal.fire({
                title: 'Data sudah benar?',
                //text: "You won't be able to revert this!",
                icon: 'warning',
                showCancelButton: true,
                confirmButtonColor: '#007bff',
                cancelButtonColor: '#6c757d',
                confirmButtonText: 'Submit!'
                }).then((result) => {

                if (result.isConfirmed) {

                    $.ajax({
                        url: "<?=site_url('attend_settings/delete_data');?>",
                        type: "post",
                        data: {
                            id: id
                        },
                        beforeSend: function () {
                            $('.modal-loading').modal('show');
                        },
                        success: function () {
                            $('.modal-loading').modal('hide');

                            Swal.fire({
                                position: 'center',
                                icon: 'success',
                                title: 'Data berhasil disimpan',
                                showConfirmButton: false,
                                timer: 1500
                            });

                            setTimeout( function () {
                                load_data();
                            }, 1500);
                        }
                    });
                }
            });
        }

        function update_data(id) {

            var ac_payroll_item_id   = $('#ac-payroll-item-id-' + id).val();
            var shift                = $('#shift-' + id).val();
            var time_scan            = $('#time-' + id).val();
            var attend               = $('#attend-' + id).val();
            var attend_status        = $('#attend-status-' + id).val();
            var hrd_act              = $('#hrd-act-' + id).val();
            var mood                 = $('#mood-' + id).val();

            $.ajax({
                url: "<?=site_url('attend_settings/update_attend');?>",
                type: "post",
                data: {
                    ac_payroll_item_id: ac_payroll_item_id,
                    shift: shift,
                    time_scan: time_scan,
                    attend: attend,
                    attend_status: attend_status,
                    hrd_act: hrd_act,
                    mood: mood,
                    id: id
                },
                beforeSend: function () {
                    $('.modal-loading').modal('show');
                },
                success: function () {
                    $('.modal-loading').modal('hide');

                    Swal.fire({
                        position: 'center',
                        icon: 'success',
                        title: 'Data berhasil disimpan',
                        showConfirmButton: false,
                        timer: 1500
                    });

                    setTimeout( function () {
                        load_data();
                    }, 1500);
                }
            });

        }

    </script>

