    
    <div class="row">

        <div class="col-md-12">

            <div class="card">

                <div class="card-body">

                    <div class="form-inline float-sm-left">
                        <div class="input-group p-1">
                            <select class="form-control select2" name="department" id="department">
                                <option selected disabled>Pilih Department</option>
                                <?php
                                foreach ($department as $row):
                                    echo '<option value="' . $row->id . '">' . $row->name . '</option>';
                                endforeach;
                                ?>
                            </select>
                        </div>
                    </div>

                </div>

            </div>
            
        </div>

    </div>

    <div class="row">

    	<div class="col-md-6">

    		<div class="card card-primary">
				
				<div class="card-header">
					<h3 class="card-title">Tambah Team</h3>

				</div>

				<form id="form-new-ansena-team" role="form" method="post" action="<?=site_url('ansena_team/save_new_ansena_team');?>">

				<div class="card-body">

					<div class="form-group">

						<label for="dept">Department</label>
						<select id="dept_id" name="dept_id" class="form-control select2" style="width: 100%">
							<option value="" selected disabled>Pilih Department</option>
							<?php foreach ($department as $row) :
								echo '<option value="' . $row->id . '">' . $row->name . '</option>';
							endforeach; ?>
						</select>


					</div>

					<div class="form-group">

						<label for="team_name">Nama Team</label>
						<input type="text" id="team_name" name="team_name"
							   class="form-control">

					</div>

				</div>
				<!-- /div.card-body -->

				<div class="card-footer">
					<button type="submit" class="btn btn-primary float-right">Submit</button>
				</div>
				<!-- /div.card-footer -->

				</form>

			</div>
			<!-- /div.card -->

			<div class="card card-secondary">
                
                <div class="card-header">
                    <h3 class="card-title">Data Team</h3>
                </div>
                
                <div class="card-body">    

                    <table id="tableTeam" class="table table-bordered table-valign-middle">

                        <thead>

                            <tr>
                                <th>Department</th>
                                <th>Team</th>
                                <th>Aksi</th>
                            </tr>

                        </thead>

                        <tbody>

                        </tbody>

                    </table>

                </div>
                <!-- /div.card-body -->

            </div>
            <!-- /div.card -->

            <div id="form-edit-ansena-team"></div>

    	</div>

		<div class="col-md-6">

			<div id="ansena-team"></div>

		</div>
		<!-- /div.col -->

	</div>

	<script>

        var titleExport = "Data Team";
        var columnExport = [ ':visible:not(.not-export-col)' ];

		$(document).ready( function () {

            $('#department').on('change', function () {

                var dept_id = $(this).val();

                $.ajax({
                    url: "<?=site_url('ansena_team/form_select_ansena_team');?>",
                    type: "get",
                    data: {
                        dept_id: dept_id
                    },
                    cache: false,
                    beforeSend: function() {
                        var loading = '<div class="overlay text-center"><i class="fas fa-3x fa-sync-alt fa-spin"></i><div class="text-bold pt-2">Loading...</div></div>';
                        $('#ansena-team').html(loading);
                    },
                    success: function(response) {

                        $('#ansena-team').html(response);
                    }

                });

            });

			$(document).on('click', '#btn-confirm-delete', function () {
                var id = $(this).attr('key');

                 Swal.fire({
                    title: 'Hapus data?',
                    //text: "You won't be able to revert this!",
                    icon: 'warning',
                    showCancelButton: true,
                    confirmButtonColor: '#dc3545',
                    cancelButtonColor: '#6c757d',
                    confirmButtonText: 'Ya!'
                    }).then((result) => {

                    if (result.isConfirmed) {

                        $.ajax({

                            url: "<?=site_url('ansena_team/delete_team');?>",
                            type: "post",
                            data: {
                                id: id
                            },
                            success: function(response) {

                                if (response == 'success') {

                                    $('#modal-confirm-delete').modal('hide');

                                    Swal.fire({
                                        position: 'center',
                                        icon: 'success',
                                        title: 'Data berhasil dihapus',
                                        showConfirmButton: false,
                                        timer: 1500
                                    });

                                    setTimeout(function(){
                                        $('#tableTeam').DataTable().ajax.reload();
                                    }, 2000);

                                } else if (response == 'error') { 
                                
                                    Swal.fire({
                                        icon: 'error',
                                        title: 'Oops...',
                                        text: 'Ada kesalahan!',
                                    });

                                }

                            }

                        });

                    }

                });
            });

            $('#tableTeam thead tr').clone(true).appendTo('#tableTeam thead');

            $('#tableTeam thead tr:eq(1) th').each( function (i) {
            
                var title = $(this).text();

                switch (i) {

                    case 2 :

                        $(this).html('');

                        break;

                    default :

                        $(this).html('<input type="text" class="form-control" placeholder="Cari ' + title + '" />');

                        break;

                }

                $('input', this).on('change', function () {

                    tableTeam
                        .column(i)
                        .search(this.value)
                        .draw();

                });

            });
            // End of clone thead

            var tableTeam = $('#tableTeam').DataTable({

                // Data
                ajax: {
                    url: "<?=site_url('ansena_team/server_side_data');?>",
                    type: "POST"
                },
                processing: true,
                serverSide: true,

                // Ordering
                order: [0, 'asc'],
                // colReorder: true,
                orderCellsTop: true,

                // Length
                lengthChange: false,
                lengthMenu: [
                    [ 10, 25, 50, 100],
                    [ '10 rows', '25 rows', '50 rows', '100 rows']
                ],

                // Column
                columnDefs: [
                                {  
                                    targets: [ 2 ],
                                    orderable: false,                                
                                    className: "not-export-col"
                                }
                            ],
                columns: [
                            {
                                "width": "40%"
                            },
                            {
                                "width": "40%"
                            },
                            {
                                "width": "20%"
                            }
                        ]
            });

			$('#form-new-ansena-team').validate({

				rules: {
					dept_id: {
						required: true
					},
					team_name: {
						required: true
					}
				},
				messages: {
					dept_id: {
						required: 'Pilih Department'
					},
					team_name: {
						required: 'Kolom nama team harus diisi'
					}
				},
				errorElement: 'span',
				errorPlacement: function (error, element) {
					error.addClass('invalid-feedback');
					element.closest('.form-group').append(error);
				},
				highlight: function (element, errorClass, validClass) {
					$(element).addClass('is-invalid');
				},
				unhighlight: function (element, errorClass, validClass) {
					$(element).removeClass('is-invalid');
				},
				submitHandler: function (form) {

					Swal.fire({
	                    title: 'Data sudah benar?',
	                    //text: "You won't be able to revert this!",
	                    icon: 'warning',
	                    showCancelButton: true,
	                    confirmButtonColor: '#007bff',
	                    cancelButtonColor: '#6c757d',
	                    confirmButtonText: 'Submit!'
	                    }).then((result) => {

	                    if (result.isConfirmed) {

	                    	$.ajax({
					            url: form.action,
					            type: form.method,
					            data: $(form).serialize(),
					            success: function(response) {

					            	if (response == 'success') {

					            		setTimeout(function(){

											$('#form-new-ansena-team input').removeClass('is-valid');
											$('#form-new-ansena-team select').removeClass('is-valid');
											$(form)[0].reset();	

											$("#form-new-ansena-team .select2").val('').trigger('change') ;

										}, 1000);

					            		Swal.fire({
											position: 'center',
											icon: 'success',
											title: 'Data berhasil disimpan',
											showConfirmButton: false,
											timer: 1500
										});

                                        setTimeout(function(){

                                            $('#tableTeam').DataTable().ajax.reload();
                                        }, 2000);

					            	} else if (response == 'error-null') {

					            		setTimeout(function(){

											$('#form-new-ansena-team input').addClass('is-invalid');
											$('#form-new-ansena-team select').addClass('is-invalid');

										}, 1000);

					            		Swal.fire({
											icon: 'error',
											title: 'Oops...',
											text: 'Ada kesalahan!',
										});

					            	} else if (response == 'error-duplicate-team') {

					            		setTimeout(function(){

											$('#team_name').addClass('is-invalid');

										}, 1000);

					            		Swal.fire({
											icon: 'error',
											title: 'Oops...',
											text: 'Nama team sudah terdaftar!'
										});

					            	}

					            }
					            // End of success

					        });
					        // End of ajax submit

	                   	}

	                });

				}
				// End of submitHandler

			});
			// End of form validate

		});
		// End of function()

        function edit_ansena_team(id) {

            $.ajax({
                url: "<?=site_url('ansena_team/form_edit_ansena_team');?>",
                type: "get",
                data: {
                    ansena_team_id: id
                },
                cache: false,
                beforeSend: function() {
                    var loading = '<div class="overlay text-center"><i class="fas fa-3x fa-sync-alt fa-spin"></i><div class="text-bold pt-2">Loading...</div></div>';
                    $('#form-edit-ansena-team').html(loading);
                },
                success: function(response) {

                    $('#form-edit-ansena-team').html(response);

                    setTimeout(function () {
                        window.scrollTo(0,document.body.scrollHeight);
                    }, 1000);
                }

            });
        }

	</script>