
<!-- Font Awesome v5.14.0 -->
<link rel="stylesheet" href="<?=base_url();?>assets/vendor/fontawesome/css/all.min.css?v5.14.0">

<style>
	.dt-buttons {
		padding: 10px;
	}
</style>

    <div class="row">

        <div class="col-md-12">

            <div class="card">

                <div class="card-body">

                    <div class="form-inline float-sm-left">
                        <div class="input-group p-1">
                            <input type="text" class="form-control monthly-datepicker" name="month" id="month" placeholder="Pilih periode" readonly>
                        </div>
                        <button type="button" class="btn btn-primary" id="btn-submit">Submit</button>
                    </div>

                </div>

            </div>

        </div>

    </div>

    <div class="row">

        <div class="col-md-12">

            <div class="card">
                <div class="card-header">
                    <h3 class="card-title">Data Keterlambatan Bulanan <?php echo $period;?></h3>
                </div>
                <div class="card-body p-0">

                    <table id="table-attend" class="table table-head-fixed table-sm m-0" style="width: 100%">

                    <?php

                    echo '<thead>';

                    echo '<tr class="txt-center">';

                        echo '<th>Name</th>';
                        echo '<th>Department</th>';
                        echo '<th>Division</th>';
                        echo '<th>Total Keterlambatan</th>';
                        echo '<th>Peringatan Bulan Ini</th>';

                    echo '</tr>';

                    echo '</thead>';

                    $paramTerlambat = array();

                    foreach ($masterData as $row) :

                        $key = 'i' . $row->id;

                        $paramTerlambat[$key] = 0;

                        echo '<tr>';

                            for ($i = 0; $i < count($attendData); $i++) :

                                $result = json_decode($attendData[$i]['detail'], TRUE);

                                if (isset($result[$key])) {

                                    switch ($result[$key]['attend_status']) :

                                        case 'TERLAMBAT':
                                            $paramTerlambat[$key] += 1;
                                            break;

                                    endswitch;

                                }

                            endfor;

                        echo '</tr>';
                        
                        if ($paramTerlambat[$key] > 3) {
                            
                            echo '<tr>';
                            echo '<td>' . $row->name . '</td>';
                            
                            if ($row->team == '') {
                                $department = $row->department;
                            } else {
                                $department = $row->department . ' (' . $row->team . ')';
                            }
                            
                            echo '<td>' . $department . '</td>';
                            echo '<td>' . $row->division . '</td>';
                            echo '<td class="text-center">' . $paramTerlambat[$key] . '</td>';

                            $warning = '';
                            if (isset($arrayWarning[$key])) {
                                $warning = $arrayWarning[$key];
                            }

                            echo '<td class="text-center">' . $warning . '</td>';

                            echo '</tr>';

                        }

                    endforeach;

                ?>

                </table>
                </div>
            </div>

        </div>

    </div>

    <div class="row">

        <div class="col-md-12">

            <div class="card">

                <div class="card-body">

                    <table class="table table-hover table-sm table-borderless m-0">

                    <?php

                    echo '<thead>';

                    echo '<tr class="text-center">';

                        echo '<th rowspan="2" style="vertical-align:middle; border-bottom:1px solid #e5e5e5">Department</th>';

                        echo '<th colspan="' . count($attendData) . '" style="border-bottom:1px solid #e5e5e5;border-left:1px solid #e5e5e5;;border-right:1px solid #e5e5e5">' . date_format(date_create($attendData[0]['attend_date']), 'F Y') . '</th>';

                        echo '<th rowspan="2" class="text-center" style="vertical-align:middle; border-bottom:1px solid #e5e5e5">Nilai</th>';

                    echo '</tr>';

                    echo '<tr class="text-center">';

                        for ($i = 0; $i < count($attendData); $i++) {

                            if (date_format(date_create($attendData[$i]['attend_date']), 'w') == 0) {
                                echo '<th class="weekend" style="border:1px solid #e5e5e5">';
                            } else {
                                echo '<th style="border:1px solid #e5e5e5">';
                            }

                            echo date_format(date_create($attendData[$i]['attend_date']), 'd') . '</th>';
                        }

                    echo '</tr>';

                    echo '</thead>';
                    ?>

                    <tbody>

                        <?php 
                        foreach ($departmentMaster as $row) :
                            echo '<tr>';
                            echo '<td style="border-right:1px solid #e5e5e5">' . $row->name . '</td>';

                            for ($i = 0; $i < count($attendData); $i++) {
                                if (date_format(date_create($attendData[$i]['attend_date']), 'w') == 0) {
                                    echo '<td class="weekend text-center" style="border-right:1px solid #e5e5e5">';
                                } else {
                                    echo '<td class="text-center" style="border-right:1px solid #e5e5e5">';
                                }
                                echo '<span class="result" id="result-' . $row->id . '_' . date_format(date_create($attendData[$i]['attend_date']), 'Y-m-d') . '" data-id="' . $row->id . '_' . date_format(date_create($attendData[$i]['attend_date']), 'Y-m-d') . '"></span></td>';
                            }
                            echo '<td class="text-center"><span class="total-result" id="tresult-' . $row->id . '_' . date_format(date_create($attendData[0]['attend_date']), 'Y-m') . '" data-id="' . $row->id . '_' . date_format(date_create($attendData[0]['attend_date']), 'Y-m') . '"></span></td>';
                            echo '</tr>';

                        endforeach;
                        ?>

                    </tbody>

                    </table>

                </div>

            </div>

        </div>

    </div>

<script>

	$(document).ready( function() {

        var period = "<?php echo $period;?>";
        
		var titleExport = 'Keterlambatan ' + period;

        $('#btn-submit').click( function () {

            var month = $('#month');

            if (month.val() == '') {
                Swal.fire({
                    position: 'center',
                    icon: 'warning',
                    title: 'Pilih periode',
                    showConfirmButton: false,
                    timer: 1000
                });

                    month.focus();

                return false;
            }
            
            location.href = "<?=site_url('attend/monthly_report_late');?>/" + month.val();

        });

        $('.result').each(function () {

            var value = $(this).data('id');

            $.ajax({
                url:"<?=site_url('attend/monthly_report_late_dept');?>",
                type:"post",
                data: {
                    value: value
                },
                beforeSend: function() {
                    var loading = '<div class="overlay text-center"><div class="text-bold pt-2">...</div></div>';
                    $('#result-' + value).html(loading);
                },
                success:function(response) {
                    $('#result-' + value).html(response + '<small>%</small>');
                }
            })

        });

        $('.total-result').each(function () {

            var value = $(this).data('id');

            $.ajax({
                url:"<?=site_url('attend/monthly_report_late_dept_total');?>",
                type:"post",
                data: {
                    value: value
                },
                beforeSend: function() {
                    var loading = '<div class="overlay text-center"><div class="text-bold pt-2">...</div></div>';
                    $('#tresult-' + value).html(loading);
                },
                success:function(response) {
                    $('#tresult-' + value).html(response + '<small>%</small>');
                }
            })

        });

	});

</script>