<!doctype html>

<html>

<head>
    <title>
        App Scanner Page
    </title>

    <meta charset="utf-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1">
    <meta name="viewport" content="width=device-width, height=devide-height">
    <meta name="robots" content="NOINDEX,NOFOLLOW">


    <!-- Bootstrap v4.5.2 -->
    <link rel="stylesheet" href="<?=base_url();?>assets/bootstrap/css/bootstrap.min.css?v4.5.2">

    <!-- DataTables v1.10.22 -->
    <link rel="stylesheet" href="<?=base_url();?>assets/vendor/datatables/datatables.min.css?v1.10.22">

    <!-- DataTables v1.10.22 with Bootstrap v4.4.11 -->
    <link rel="stylesheet" href="<?=base_url();?>assets/vendor/datatables/datatables/css/dataTables.bootstrap4.min.css?v4.4.11">

    <link rel="stylesheet" href="<?=base_url();?>assets/vendor/toastr/toastr.min.css">

    <!-- jQuery v3.5.1 -->
    <script src="<?=base_url();?>assets/vendor/jquery/jquery-3.5.1.min.js?v3.5.1"></script>

    <!-- Bootstrap v4.5.2 -->
    <script src="<?=base_url();?>assets/bootstrap/js/bootstrap.min.js?v4.5.2"></script>

    <!-- jQuery DataTables v1.10.22 -->
    <script src="<?=base_url();?>assets/vendor/datatables/datatables/js/jquery.dataTables.min.js?v1.10.22"></script>

    <!-- DataTables v1.10.22 with Bootstrap v4.4.11 -->
    <script src="<?=base_url();?>assets/vendor/datatables/datatables/js/dataTables.bootstrap4.min.js?v4.4.11"></script>

    <!-- Toastr -->
    <script src="<?=base_url();?>assets/vendor/toastr/toastr.min.js"></script>

    <style>

    	html {
  			scroll-behavior: smooth;
    	}

    	body {
			overflow-y: hidden;
    		background: url('<?=base_url();?>assets/background/background.jpg') no-repeat center fixed;
    		background-size: cover;
    		font-family: -apple-system, BlinkMacSystemFont;
    	}

    	#logo-ans {
    		width: 75px;
    		height: auto;
    		float: right;
    	}

    	h1 {
    		font-size: 65px;
    	}

    	p {
    		margin-bottom: 5px;
    	}

    	h3 {
    		margin-bottom: 15px;
    	}
    	#tableAttend tbody {
    		font-size: 12px;
    	}

    	.form-control, .form-control:focus {
    		border-radius: 0;
    		border-color: white !important;
    		font-size: 20px;
    		box-shadow: 10px 10px 17px 2px rgba(0,0,0,0.31);
    	}

		#modal-xl {
			top: 20vw;
		}

		@media (min-width: 576px) {
			.modal-dialog {
				max-width: 500px !important;
				margin: 1.75rem auto;
			}
		}

		@media (min-width: 992px) {
			.modal-dialog {
				max-width: 800px !important;
				margin: 1.75rem auto;
			}
		}

		@media (min-width: 1200px) {
			.modal-dialog {
				max-width: 1100px !important;
				margin: 1.75rem auto;
			}
		}

    </style>

    <script>

        function insertRow(e) {

            var row = tableAttend.insertRow(1);
            var cell1 = row.insertCell(0);
            var cell2 = row.insertCell(1);
            var cell3 = row.insertCell(2);
            var cell4 = row.insertCell(3);
            var cell5 = row.insertCell(4);
			var cell6 = row.insertCell(5);
			var cell7 = row.insertCell(6);
			cell1.innerHTML = e.name;
			
			if (e.team != null) {
				cell2.innerHTML = e.department + ' (' + e.team + ')';
			} else {
				cell2.innerHTML = e.department;
			}

            cell3.innerHTML = e.division;
            cell4.innerHTML = e.shift;
			cell5.innerHTML = e.time_scan;
			cell6.innerHTML = e.attend;

            if (e.attend_status == 'TERLAMBAT') {
                cell7.innerHTML = '<div class="clr-red">' + e.attend_status + '</div>';
            } else {
                cell7.innerHTML = e.attend_status;
            }

        }

    	$(document).ready( function () {

    		var timeOut;
			var input = document.getElementById("scan");

			input.addEventListener("keyup", function(event) {

                var time = "<?php echo date('Y-m-d H:i:s');?>";

				if (event.keyCode === 13) {

					clearTimeout(timeOut);

					event.preventDefault();

					$.ajax({
			            url: "<?=site_url('attend/scan');?>",
			            type: "post",
			            data: {
                            barcode: input.value,
                            time: time
                        }, 
                        dataType: "json",
			            success: function(data) {

                            input.value = '';

			            	if (data.response == 'terlambat') {

								if (data.mood == 1 && data.insert_id != null) {

									$('#data').val(JSON.stringify(data));
									$('#insert_id').val(data.insert_id);
									$('#title').html(data.title);
									$('#modal-xl').modal('show');

								} else {
									toastr.warning('Anda terlambat');
									insertRow(data);
								}

                            } else if (data.response == 'success') {

								if (data.mood == 1 && data.insert_id != null) {

									$('#data').val(JSON.stringify(data));
									$('#insert_id').val(data.insert_id);
									$('#title').html(data.title);
									$('#modal-xl').modal('show');

								} else {
			            			toastr.success('Anda berhasil absen masuk');
                                	insertRow(data);
								}

			            	} else if (data.response == 'success-out') {

								if (data.mood == 1 && data.insert_id != null) {

									$('#data').val(JSON.stringify(data));
									$('#insert_id').val(data.insert_id);
									$('#title').html(data.title);
									$('#modal-xl').modal('show');

								} else {
                                	toastr.success('Anda berhasil absen keluar');
                                	insertRow(data);
								}

                            } else if (data.response == 'break-in') {

                                toastr.success('Anda telah selesai istirahat');
                                insertRow(data);

                            } else if (data.response == 'break-out') {

                                toastr.success('Selamat beristirahat!');
                                insertRow(data);

                            } else if (data.response == 'break-late') {

                                toastr.warning('Anda terlambat!');
                                insertRow(data);

                            } else if (data.response == 'exists') {

                                toastr.info('Anda sudah absen');

                            } else if (data.response == 'cant-scan') {

								if (data.time_scan != '') {
									toastr.error('Anda tidak dapat melakukan absen<br>Absen terakhir: ' + data.attend + ' - ' + data.time_scan + ' (Shift:' + data.shift + ')');
								} else {
									toastr.error('Anda tidak dapat melakukan absen');
								}

                            } else if (data.response == 'error-expired') {

                                toastr.error('Barcode sudah tidak berlaku');

                            } else if (data.response == 'error-used') {

                                toastr.error('Barcode sudah digunakan');

                            } else if (data.response == 'error-date-contract-finished') {

								toastr.error('Masa kerja anda sudah habis');

							} else if (data.response == 'error-null') {

			            		toastr.error('Barcode tidak terdaftar');

			            	} 

			            }
			            // End of success function

			        });
			        // End of ajax

				}
				// End of keycode

			});
			// End of keyup

			$('#tableAttend').DataTable({
				// Data
                ajax: {
                    url: "<?=site_url('attend/server_side_data');?>",
                    type: "POST"
                },
                processing: true,
                serverSide: true,
                paging: false,
                searching: false,
                info: false,
                ordering: false,
                scrollY: '23vw',
                scrollCollapse: true,
                "oLanguage": {
                    "sEmptyTable": "-"
                }

			});

			$("body").on("shown.bs.modal", "#modal-xl", function () {

				$('#scan').attr('disabled', 'disabled');

			});

			$("body").on("hidden.bs.modal", "#modal-xl", function () {

				$('#scan').removeAttr('disabled');

				$('#scan').focus();

			});

		});
		// End of document function
		
		var myVar = setInterval(myTimer, 1000);

		function myTimer() {
			var d = new Date();
			var t = d.toLocaleTimeString();
            var h = d.getHours();
            var m = d.getMinutes();
            var s = d.getSeconds();

            if (h == 6 && m == 0 && s == 0) {
                location.href = '<?=site_url('attend/scanner_page');?>';
            }

			document.getElementById("time").innerHTML = t;
		}

		function select_mood(mood) {

			var x = $('#data').val();
			var insert_id = $('#insert_id').val();

			$.ajax({
				url: "<?=site_url('attend/insert_mood');?>",
				type: "post",
				data: {
					insert_id: insert_id,
					mood: mood
				}, 
				success: function() {

					x = JSON.parse(x);

					$('#modal-xl').modal('hide');

					setTimeout(function () {

						if (x.response == 'terlambat') {
							toastr.warning('Anda terlambat');
							insertRow(x);
						} else if (x.response == 'success') {
							toastr.success('Anda berhasil absen masuk');
							insertRow(x);
						} else if (x.response == 'success-out') {
							toastr.success('Anda berhasil absen keluar');
							insertRow(x);
						}

					}, 500);

				}
			});

		}

    </script>

</head>

<body>

	<div id="scanner-page" class="container-fluid" style="height: 100vh;">

		<div class="row row-header">

			<div class="col-md-6" style="padding-left:3vw;padding-top:3vw">
				<h3><?php echo date_format(date_create(), 'd F Y');?>
				<div id="time"></div>
			</h3>
			</div>
			<!-- /div.col -->

			<div class="col-md-6">
				<img src="<?=base_url();?>assets/background/logo-ans.png" id="logo-ans" />
			</div>
			<!-- /div.col -->

		</div>
		<!-- /div.row -->

		<div class="row row-content">

			<div class="col-md-8" style="position:absolute;padding-left:3vw;padding-top:3vw">

				<table id="tableAttend" class="table">

					<thead>
						<tr>
							<th>Name</th>
							<th>Perusahaan</th>
							<th>Jabatan</th>
							<th>Shift</th>
                            <th>Waktu</th>
                            <th>IN/OUT</th>
							<th>Status</th>
						</tr>
					</thead>

					<tbody>
					</tbody>

				</table>

			</div>
			<!-- /div.col -->

			<div class="col-md-1">

			</div>
			<!-- /div.col -->

			<div class="col-md-3" style="position:absolute;right:5vw;bottom:10vw">
				<p>Barcode Scan :</p>
				<input type="text" class="form-control" name="barcode" id="scan" autofocus onblur="$(this).focus();">				
			</div>
			<!-- /div.col -->

		</div>
		<!-- /div.row -->

		<div class="row row-footer">

			<div class="col-md-6" style="position:absolute;bottom:0;left:0">
				for a better future life<br>
				&copy; 2010 - 2020
			</div>
			<!-- /div.col -->

			<div class="col-md-6" style="position:absolute;bottom:0;right:0">
				<br>
				<p class="float-right">www.ansena.com</p>
			</div>
			<!-- /div.col -->

		</div>
		<!-- /div.row -->

	</div>
	<!-- /div.container -->


    <div class="modal fade" id="modal-xl" data-backdrop="static">
        <div class="modal-dialog modal-xl">
            <div class="modal-content">
                <div class="modal-body">

					<input type="hidden" id="data">
					<input type="hidden" id="insert_id">

					<h3 class="text-center" id="title"></h3>

					<br>

					<div class="row">
						<!-- <div class="col-sm-2">
						</div> -->
						<div class="col-sm-2 text-center">
							<img onclick="select_mood(1)" src="<?=base_url();?>assets/emoot/senang.svg" style="width:50px">
							<p class="text-center">senang</p>
						</div>
						<div class="col-sm-2 text-center">
							<img onclick="select_mood(2)" src="<?=base_url();?>assets/emoot/sedih.svg" style="width:50px"/>
							<p class="text-center">sedih</p>
						</div>
						<!-- <div class="col-sm-1 text-center">
							<img onclick="select_mood(3)" src="<?=base_url();?>assets/emoot/marah.svg" style="width:50px"/>
							<p class="text-center">marah</p>
						</div> -->
						<div class="col-sm-2 text-center">
							<img onclick="select_mood(4)" src="<?=base_url();?>assets/emoot/bosan.svg" style="width:50px"/>
							<p class="text-center">bosan</p>
						</div>
						<div class="col-sm-2 text-center">
							<img onclick="select_mood(5)" src="<?=base_url();?>assets/emoot/biasa.svg" style="width:50px"/>
							<p class="text-center">biasa</p>
						</div>
						<div class="col-sm-2 text-center">
							<img onclick="select_mood(6)" src="<?=base_url();?>assets/emoot/tertekan.svg" style="width:50px"/>
							<p class="text-center">tertekan</p>
						</div>
						<div class="col-sm-2 text-center">
							<img onclick="select_mood(7)" src="<?=base_url();?>assets/emoot/sakit.svg" style="width:50px"/>
							<p class="text-center">sakit</p>
						</div>
						<!-- <div class="col-sm-1 text-center">
							<img onclick="select_mood(8)" src="<?=base_url();?>assets/emoot/cinta.svg" style="width:50px"/>
							<p class="text-center">cinta</p>
						</div> -->
						<!-- <div class="col-sm-2">
						</div> -->
					</div>

                </div>
            </div>
            <!-- /.modal-content -->
        </div>
        <!-- /.modal-dialog -->
    </div>
    <!-- /.modal -->


</body>

</html>