
    <div class="row">

        <div class="col-8 offset-2">

            <div class="card">

                <form id="form-working-time">
                <div class="card-body table-responsive p-0" style="max-height:500px">

                    <table id="table-working-time" class="table table-head-fixed">

                        <thead class="text-center">
                            <tr>
                                <th>Department</th>
                                <th>Working Time</th>
                            </tr>
                        </thead>

                        <tbody></tbody>

                    </table>

                </div>
                <!--/.card-body -->

                <div class="card-footer">
                    <button type="submit" class="btn btn-primary">Submit</button>
                </div>
                <!--/.card-footer -->
                </form>

                <div id="loading-working-time"></div>
            </div>
            <!--/.card -->

        </div>
        <!--/.col -->

    </div>
    <!--/.row -->

    <script>

        $(document).ready( function () {
            get_working_time();
        });

        function get_working_time() {

            $.ajax({
                url: "<?=site_url('attend_settings/load_working_time');?>",
                dataType: "json",
                beforeSend: function () {
                    var loading = '<div class="overlay dark"><div class="spinner-border ms-auto" role="status" aria-hidden="true"></div></div>';
                    $('#loading-working-time').html(loading);
                },
                success: function (data) {

                    $('#loading-working-time').html('');

                    for (i = 0; i < data.length; i++) {
                        append_row(data[i], i);
                    }
                }
            });
        }

        function append_row(data, i) {

            var tableWorkingTime = document.getElementById('table-working-time').getElementsByTagName('tbody')[0];

            var l = tableWorkingTime.rows.length;
            var row = tableWorkingTime.insertRow(l);

            var cell1 = row.insertCell(0);
            var cell2 = row.insertCell(1);

            var attend = data.attend;

            cell1.innerHTML = data.name + '<input type="hidden" name="id[]" value="' + data.id + '">';
            cell2.innerHTML = '<textarea class="form-control form-control-sm" name="working_time[]">' + attend + '</textarea>';
        }

        $('#form-working-time').submit( function (e) {
            e.preventDefault();

            Swal.fire({
            title: 'Apakah data sudah benar?',
            //text: "You won't be able to revert this!",
            icon: 'warning',
            showCancelButton: true,
            confirmButtonColor: '#007bff',
            cancelButtonColor: '#6c757d',
            confirmButtonText: 'Submit!'
            }).then((result) => {

                if (result.isConfirmed) {

                    $.ajax({
                        url: "<?=site_url('attend_settings/save_working_time');?>",
                        type: "post",
                        data: $(this).serialize(),
                        dataType: "json",
                        success: function (response) {

                            if (response == 'success') {

                                Swal.fire({
                                    position: 'center',
                                    icon: 'success',
                                    title: 'Data berhasil disimpan',
                                    showConfirmButton: false,
                                    timer: 1500
                                });

                                setTimeout( function () {
                                    get_working_time();
                                }, 1500);
                            } else {

                                Swal.fire({
                                    position: 'center',
                                    icon: 'warning',
                                    title: 'Ops! Ada kesalahan!',
                                    showConfirmButton: false,
                                    timer: 1000
                                });
                            }
                        }
                    })

                }
            });
        
        });

    </script>

